/*
 *      nanoMir
 *
 *      "fs.h           File system
 */

#ifdef VMS
#include <types.h>
#else
#include <sys/types.h>
#endif

typedef small fid;
extern void fsInit (void);
extern bool FsParse (char *, char *);	/* (filnam, buf for canonical name) */
extern bool FsInfo (txt *);
extern fid FsOpen (char *, small);	/* (filnam, mode) */
extern large FsRead (fid, large, char *);	/* (fid, size, buf) */
extern large FsWrite (fid, large, char *);	/* (fid, size, buf) */
extern bool FsClose (fid);
extern bool FsDelete (char *);
extern char *FsRename (char *, char *);	/* (oldfilnam, newfilnam) */
extern time_t FsTime (void);
extern char *dttm (time_t);
extern void FsSetDef (txt *);
extern bool FsCheck (txt *);
extern bool FsAccess (char *s, int mode);

extern char fullname[];
extern small Fsddlen;
extern small Fsnmlen;
extern small Fsext;
extern bool Fsiswild;
extern char fsDefExt[];
extern char *FsName;

extern char *FsUname;
extern char *FsGname;

#include <errno.h>
#define MAXNAME 14
#ifdef UNIX
#define FE_NSF    (1 - FE_MIN)
#define FE_MIN     101
#define FE_SYNT   -101
#define FE_NSDRV  -102
#define FE_NSDIR  -103
#define FE_IOERR  -104
#define FE_NSFIL  -105
#define FE_DIR    -106
#endif
#ifdef VMS
#include <rmsdef.h>
#define FE_NSF ENOENT		/* Unix's No such file or directory */
#endif
/* modes for FsOpen */
#define FO_READ   0		/* Read  only */
#define FO_WRITE  1		/* Write only */
#define FO_UPDATE 2		/* Read and write */
#define FO_NEW    3		/* New file for write */
