/*
 *     nanoMir
 *
 *     "kbq.c"          Keyboard queue
 */

#define MAXKBQUEUE 1024
static unsigned char kbqueue[MAXKBQUEUE], *qpo, *qpi;

static void
kbqinit ()
{
  qpi = kbqueue;
  qpo = kbqueue + MAXKBQUEUE;
}

static unsigned char *
kbqnext (unsigned char *p)
{
  if (++p >= kbqueue + MAXKBQUEUE)
    p = kbqueue;
  return p;
}

static bool
qkbqempty ()
{
  return kbqnext (qpo) == qpi;
}

static unsigned char
kbqget ()
{
  if (qkbqempty ())
    return -1;
  qpo = kbqnext (qpo);
  return *qpo;
}

static void
kbqput (unsigned char c)
{
  *qpi = c;
  qpi = kbqnext (qpi);
}
