/*
 *     nanoMir
 *
 *     "keytable.c"     Key table support
 */

/* Direct and reverce mapping for russian keyboard for PC. */
static const unsigned char keytable[256] = {
  /* 00   */ ' ',
  /* 01   */ ' ',
  /* 02   */ ' ',
  /* 03   */ ' ',
  /* 04   */ ' ',
  /* 05   */ ' ',
  /* 06   */ ' ',
  /* 07   */ ' ',
  /* 08   */ ' ',
  /* 09   */ ' ',
  /* 0a   */ ' ',
  /* 0b   */ ' ',
  /* 0c   */ ' ',
  /* 0d   */ ' ',
  /* 0e   */ ' ',
  /* 0f   */ ' ',
  /* 10   */ ' ',
  /* 11   */ ' ',
  /* 12   */ ' ',
  /* 13   */ ' ',
  /* 14   */ ' ',
  /* 15   */ ' ',
  /* 16   */ ' ',
  /* 17   */ ' ',
  /* 18   */ ' ',
  /* 19   */ ' ',
  /* 1a   */ ' ',
  /* 1b   */ ' ',
  /* 1c   */ ' ',
  /* 1d   */ ' ',
  /* 1e   */ ' ',
  /* 1f   */ ' ',
  /* 20   */ ' ',
  /* 21 ! */ '!',
  /* 22 " */ '',
  /* 23 # */ '#',
  /* 24 $ */ '$',
  /* 25 % */ '%',
  /* 26 & */ '&',
  /* 27 ' */ '',
  /* 28 ( */ '(',
  /* 29 ) */ ')',
  /* 2a * */ '*',
  /* 2b + */ '+',
  /* 2c , */ '',
  /* 2d - */ '-',
  /* 2e . */ '',
  /* 2f / */ '/',
  /* 30 0 */ '0',
  /* 31 1 */ '1',
  /* 32 2 */ '2',
  /* 33 3 */ '3',
  /* 34 4 */ '4',
  /* 35 5 */ '5',
  /* 36 6 */ '6',
  /* 37 7 */ '7',
  /* 38 8 */ '8',
  /* 39 9 */ '9',
  /* 3a : */ '',
  /* 3b ; */ '',
  /* 3c < */ '',
  /* 3d = */ '=',
  /* 3e > */ '',
  /* 3f ? */ '?',
  /* 40 @ */ '@',
  /* 41 A */ '',
  /* 42 B */ '',
  /* 43 C */ '',
  /* 44 D */ '',
  /* 45 E */ '',
  /* 46 F */ '',
  /* 47 G */ '',
  /* 48 H */ '',
  /* 49 I */ '',
  /* 4a J */ '',
  /* 4b K */ '',
  /* 4c L */ '',
  /* 4d M */ '',
  /* 4e N */ '',
  /* 4f O */ '',
  /* 50 P */ '',
  /* 51 Q */ '',
  /* 52 R */ '',
  /* 53 S */ '',
  /* 54 T */ '',
  /* 55 U */ '',
  /* 56 V */ '',
  /* 57 W */ '',
  /* 58 X */ '',
  /* 59 Y */ '',
  /* 5a Z */ '',
  /* 5b [ */ '',
  /* 5c \ */ '\\',
  /* 5d ] */ '',
  /* 5e ^ */ '^',
  /* 5f _ */ '_',
  /* 60 ` */ '`',
  /* 61 a */ '',
  /* 62 b */ '',
  /* 63 c */ '',
  /* 64 d */ '',
  /* 65 e */ '',
  /* 66 f */ '',
  /* 67 g */ '',
  /* 68 h */ '',
  /* 69 i */ '',
  /* 6a j */ '',
  /* 6b k */ '',
  /* 6c l */ '',
  /* 6d m */ '',
  /* 6e n */ '',
  /* 6f o */ '',
  /* 70 p */ '',
  /* 71 q */ '',
  /* 72 r */ '',
  /* 73 s */ '',
  /* 74 t */ '',
  /* 75 u */ '',
  /* 76 v */ '',
  /* 77 w */ '',
  /* 78 x */ '',
  /* 79 y */ '',
  /* 7a z */ '',
  /* 7b { */ '',
  /* 7c | */ '|',
  /* 7d } */ '',
  /* 7e ~ */ '~',
  /* 7f   */ ' ',
  /* 80  */ '',
  /* 81  */ '',
  /* 82  */ '',
  /* 83  */ '',
  /* 84  */ '',
  /* 85  */ '',
  /* 86  */ '',
  /* 87  */ '',
  /* 88  */ '',
  /* 89  */ '',
  /* 8a  */ '',
  /* 8b  */ '',
  /* 8c  */ '',
  /* 8d  */ '',
  /* 8e  */ '',
  /* 8f  */ '',
  /* 90  */ '',
  /* 91  */ '',
  /* 92  */ '',
  /* 93  */ '',
  /* 94  */ '',
  /* 95  */ '',
  /* 96  */ '',
  /* 97  */ '',
  /* 98  */ '',
  /* 99  */ '',
  /* 9a  */ '',
  /* 9b  */ '',
  /* 9c  */ '',
  /* 9d  */ '',
  /* 9e  */ '',
  /* 9f  */ '',
  /* a0  */ '',
  /* a1  */ '',
  /* a2  */ '',
  /* a3  */ '',
  /* a4  */ '',
  /* a5  */ '',
  /* a6  */ '',
  /* a7  */ '',
  /* a8  */ '',
  /* a9  */ '',
  /* aa  */ '',
  /* ab  */ '',
  /* ac  */ '',
  /* ad  */ '',
  /* ae  */ '',
  /* af  */ '',
  /* b0  */ '',
  /* b1  */ '',
  /* b2  */ '',
  /* b3  */ '',
  /* b4  */ '',
  /* b5  */ '',
  /* b6  */ '',
  /* b7  */ '',
  /* b8  */ '',
  /* b9  */ '',
  /* ba  */ '',
  /* bb  */ '',
  /* bc  */ '',
  /* bd  */ '',
  /* be  */ '',
  /* bf  */ '',
  /* c0  */ '.',
  /* c1  */ 'f',
  /* c2  */ ',',
  /* c3  */ 'w',
  /* c4  */ 'l',
  /* c5  */ 't',
  /* c6  */ 'a',
  /* c7  */ 'u',
  /* c8  */ '[',
  /* c9  */ 'b',
  /* ca  */ 'q',
  /* cb  */ 'r',
  /* cc  */ 'k',
  /* cd  */ 'v',
  /* ce  */ 'y',
  /* cf  */ 'j',
  /* d0  */ 'g',
  /* d1  */ 'z',
  /* d2  */ 'h',
  /* d3  */ 'c',
  /* d4  */ 'n',
  /* d5  */ 'e',
  /* d6  */ ';',
  /* d7  */ 'd',
  /* d8  */ 'm',
  /* d9  */ 's',
  /* da  */ 'p',
  /* db  */ 'i',
  /* dc  */ '\'',
  /* dd  */ 'o',
  /* de  */ 'x',
  /* df  */ ']',
  /* e0  */ '>',
  /* e1  */ 'F',
  /* e2  */ '<',
  /* e3  */ 'W',
  /* e4  */ 'L',
  /* e5  */ 'T',
  /* e6  */ 'A',
  /* e7  */ 'U',
  /* e8  */ '{',
  /* e9  */ 'B',
  /* ea  */ 'Q',
  /* eb  */ 'R',
  /* ec  */ 'K',
  /* ed  */ 'V',
  /* ee  */ 'Y',
  /* ef  */ 'J',
  /* f0  */ 'G',
  /* f1  */ 'Z',
  /* f2  */ 'H',
  /* f3  */ 'C',
  /* f4  */ 'N',
  /* f5  */ 'E',
  /* f6  */ ':',
  /* f7  */ 'D',
  /* f8  */ 'M',
  /* f9  */ 'S',
  /* fa  */ 'P',
  /* fb  */ 'I',
  /* fc  */ '\"',
  /* fd  */ 'O',
  /* fe  */ 'X',
  /* ff  */ '}'
};

/*      ' '  ' '. */
static const unsigned char word_separators[256] = {
  /* 00   */  1 ,
  /* 01   */  1 ,
  /* 02   */  1 ,
  /* 03   */  1 ,
  /* 04   */  1 ,
  /* 05   */  1 ,
  /* 06   */  1 ,
  /* 07   */  1 ,
  /* 08   */  1 ,
  /* 09   */  1 ,
  /* 0a   */  1 ,
  /* 0b   */  1 ,
  /* 0c   */  1 ,
  /* 0d   */  1 ,
  /* 0e   */  1 ,
  /* 0f   */  1 ,
  /* 10   */  1 ,
  /* 11   */  1 ,
  /* 12   */  1 ,
  /* 13   */  1 ,
  /* 14   */  1 ,
  /* 15   */  1 ,
  /* 16   */  1 ,
  /* 17   */  1 ,
  /* 18   */  1 ,
  /* 19   */  1 ,
  /* 1a   */  1 ,
  /* 1b   */  1 ,
  /* 1c   */  1 ,
  /* 1d   */  1 ,
  /* 1e   */  1 ,
  /* 1f   */  1 ,
  /* 20   */  1 ,
  /* 21 ! */  1 ,
  /* 22 " */  1 ,
  /* 23 # */  1 ,
  /* 24 $ */  1 ,
  /* 25 % */  1 ,
  /* 26 & */  1 ,
  /* 27 ' */  1 ,
  /* 28 ( */  1 ,
  /* 29 ) */  1 ,
  /* 2a * */  1 ,
  /* 2b + */  1 ,
  /* 2c , */  1 ,
  /* 2d - */  1 ,
  /* 2e . */  1 ,
  /* 2f / */  1 , /* 0      ,     '.', '-'  ,        ... */
  /* 30 0 */  0 ,
  /* 31 1 */  0 ,
  /* 32 2 */  0 ,
  /* 33 3 */  0 ,
  /* 34 4 */  0 ,
  /* 35 5 */  0 ,
  /* 36 6 */  0 ,
  /* 37 7 */  0 ,
  /* 38 8 */  0 ,
  /* 39 9 */  0 ,
  /* 3a : */  1 ,
  /* 3b ; */  1 ,
  /* 3c < */  1 ,
  /* 3d = */  1 ,
  /* 3e > */  1 ,
  /* 3f ? */  1 ,
  /* 40 @ */  0 ,
  /* 41 A */  0 ,
  /* 42 B */  0 ,
  /* 43 C */  0 ,
  /* 44 D */  0 ,
  /* 45 E */  0 ,
  /* 46 F */  0 ,
  /* 47 G */  0 ,
  /* 48 H */  0 ,
  /* 49 I */  0 ,
  /* 4a J */  0 ,
  /* 4b K */  0 ,
  /* 4c L */  0 ,
  /* 4d M */  0 ,
  /* 4e N */  0 ,
  /* 4f O */  0 ,
  /* 50 P */  0 ,
  /* 51 Q */  0 ,
  /* 52 R */  0 ,
  /* 53 S */  0 ,
  /* 54 T */  0 ,
  /* 55 U */  0 ,
  /* 56 V */  0 ,
  /* 57 W */  0 ,
  /* 58 X */  0 ,
  /* 59 Y */  0 ,
  /* 5a Z */  0 ,
  /* 5b [ */  1 ,
  /* 5c \ */  1 ,
  /* 5d ] */  1 ,
  /* 5e ^ */  1 ,
  /* 5f _ */  0 ,
  /* 60 ` */  1 ,
  /* 61 a */  0 ,
  /* 62 b */  0 ,
  /* 63 c */  0 ,
  /* 64 d */  0 ,
  /* 65 e */  0 ,
  /* 66 f */  0 ,
  /* 67 g */  0 ,
  /* 68 h */  0 ,
  /* 69 i */  0 ,
  /* 6a j */  0 ,
  /* 6b k */  0 ,
  /* 6c l */  0 ,
  /* 6d m */  0 ,
  /* 6e n */  0 ,
  /* 6f o */  0 ,
  /* 70 p */  0 ,
  /* 71 q */  0 ,
  /* 72 r */  0 ,
  /* 73 s */  0 ,
  /* 74 t */  0 ,
  /* 75 u */  0 ,
  /* 76 v */  0 ,
  /* 77 w */  0 ,
  /* 78 x */  0 ,
  /* 79 y */  0 ,
  /* 7a z */  0 ,
  /* 7b { */  1 ,
  /* 7c | */  1 ,
  /* 7d } */  1 ,
  /* 7e ~ */  1 ,
  /* 7f   */  1 ,
  /* 80  */  1 ,
  /* 81  */  1 ,
  /* 82  */  1 ,
  /* 83  */  1 ,
  /* 84  */  1 ,
  /* 85  */  1 ,
  /* 86  */  1 ,
  /* 87  */  1 ,
  /* 88  */  1 ,
  /* 89  */  1 ,
  /* 8a  */  1 ,
  /* 8b  */  1 ,
  /* 8c  */  1 ,
  /* 8d  */  1 ,
  /* 8e  */  1 ,
  /* 8f  */  1 ,
  /* 90  */  1 ,
  /* 91  */  1 ,
  /* 92  */  1 ,
  /* 93  */  1 ,
  /* 94  */  1 ,
  /* 95  */  1 ,
  /* 96  */  1 ,
  /* 97  */  1 ,
  /* 98  */  1 ,
  /* 99  */  1 ,
  /* 9a  */  1 ,
  /* 9b  */  1 ,
  /* 9c  */  1 ,
  /* 9d  */  1 ,
  /* 9e  */  1 ,
  /* 9f  */  1 ,
  /* a0  */  1 ,
  /* a1  */  1 ,
  /* a2  */  1 ,
  /* a3  */  1 ,
  /* a4  */  1 ,
  /* a5  */  1 ,
  /* a6  */  1 ,
  /* a7  */  1 ,
  /* a8  */  1 ,
  /* a9  */  1 ,
  /* aa  */  1 ,
  /* ab  */  1 ,
  /* ac  */  1 ,
  /* ad  */  1 ,
  /* ae  */  1 ,
  /* af  */  1 ,
  /* b0  */  1 ,
  /* b1  */  1 ,
  /* b2  */  1 ,
  /* b3  */  1 ,
  /* b4  */  1 ,
  /* b5  */  1 ,
  /* b6  */  1 ,
  /* b7  */  1 ,
  /* b8  */  1 ,
  /* b9  */  1 ,
  /* ba  */  1 ,
  /* bb  */  1 ,
  /* bc  */  1 ,
  /* bd  */  1 ,
  /* be  */  1 ,
  /* bf  */  1 ,
  /* c0  */  0 ,
  /* c1  */  0 ,
  /* c2  */  0 ,
  /* c3  */  0 ,
  /* c4  */  0 ,
  /* c5  */  0 ,
  /* c6  */  0 ,
  /* c7  */  0 ,
  /* c8  */  0 ,
  /* c9  */  0 ,
  /* ca  */  0 ,
  /* cb  */  0 ,
  /* cc  */  0 ,
  /* cd  */  0 ,
  /* ce  */  0 ,
  /* cf  */  0 ,
  /* d0  */  0 ,
  /* d1  */  0 ,
  /* d2  */  0 ,
  /* d3  */  0 ,
  /* d4  */  0 ,
  /* d5  */  0 ,
  /* d6  */  0 ,
  /* d7  */  0 ,
  /* d8  */  0 ,
  /* d9  */  0 ,
  /* da  */  0 ,
  /* db  */  0 ,
  /* dc  */  0 ,
  /* dd  */  0 ,
  /* de  */  0 ,
  /* df  */  0 ,
  /* e0  */  0 ,
  /* e1  */  0 ,
  /* e2  */  0 ,
  /* e3  */  0 ,
  /* e4  */  0 ,
  /* e5  */  0 ,
  /* e6  */  0 ,
  /* e7  */  0 ,
  /* e8  */  0 ,
  /* e9  */  0 ,
  /* ea  */  0 ,
  /* eb  */  0 ,
  /* ec  */  0 ,
  /* ed  */  0 ,
  /* ee  */  0 ,
  /* ef  */  0 ,
  /* f0  */  0 ,
  /* f1  */  0 ,
  /* f2  */  0 ,
  /* f3  */  0 ,
  /* f4  */  0 ,
  /* f5  */  0 ,
  /* f6  */  0 ,
  /* f7  */  0 ,
  /* f8  */  0 ,
  /* f9  */  0 ,
  /* fa  */  0 ,
  /* fb  */  0 ,
  /* fc  */  0 ,
  /* fd  */  0 ,
  /* fe  */  0 ,
  /* ff  */  0
};
