#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>

#ifndef BIN_DIR
#define BIN_DIR "/usr/local/bin"
#endif

#define MIM     BIN_DIR"/mim.bin"
#define XMIM    BIN_DIR"/xmim.bin"

int main (int argc, char *argv[])
{
  char * envStr;
  char * bin;

  envStr = getenv ("DISPLAY");

  if (!envStr || strcmp (envStr, "") == 0)
    {
      /* DISPLAY  .   . */
      bin = MIM;
    }
  else
    {
      /* DISPLAY .  X11 . */
      bin = XMIM;

#ifdef GLIBC2
      if (daemon (1, 1))
        {
          write (STDERR_FILENO, "Cannot put itself in background!\n", 33);
          return -1;
        }
#else
      {
        int res = fork ();

        if (res == -1)
          {
            write (STDERR_FILENO, "Cannot fork!\n", 13);
          }
        else if (res != 0)
          {
            /* Parent process: terminate */
            return 0;
          }
        /* Child process (res == 0) continues */
      }
#endif /* GLIBC2 */
    }

  if (argc == 1)
    {
      /*    */
      if (execl (bin, bin, 0) == -1)
        {
          write (STDERR_FILENO, "Cannot execute image!\n", 22);
          return 1;
        }
    }
  else
    {
      /*    */
      if (execl (bin, bin, argv[1], 0) == -1)
        {
          write (STDERR_FILENO, "Cannot execute image!\n", 22);
          return 1;
        }
    }

  return 0;
}
