#!/bin/sh
# Environment for LINUX version of mim and xmim

# Terminal type for mim on console
MIMTERM=linux
export MIMTERM

# Terminal type for mim in X11
XMIMTERM=xlinux
export XMIMTERM

# Directory with terminal descriptions
MIMTERMINFO=/usr/local/lib/mim
export MIMTERMINFO

# File name for lines save
MIMLINESAVEFILE=/tmp/$LOGNAME.$$.l.mim
export MIMLINESAVEFILE

# File name for block save
MIMBLOCKSAVEFILE=/tmp/$LOGNAME.$$.b.mim
export MIMBLOCKSAVEFILE

# Global options:
#opt type      value
# a (bool)   -     
# b (bool)   -     
# c (string) -   #include-
# e (string) -    
# i (bool)   -  
# k (value)  -    
# m (value)  -     
# p (value)  -    
# q (value)  -    
# r (bool)   - Return    
# t (value)  -  
# u (bool)   -    
# v (bool)   - Case sensitive search
# w (bool)   -  
# x (string) -     
MIMOPT="a+ b+ c/usr/include/ i+ k5 m400 n64 p0 q65 r+ t8 u- v+ w+ x"$MIMTERMINFO"/"
export MIMOPT

# Possible colors for console version:
# "black" "red" "green" "yellow" "blue" "magenta" "cyan" "white"
# "lightblack" "lightred" "lightgreen" "lightyellow" "lightblue"
# "lightmagenta" "lightcyan" "lightwhite"
# Foreground color for console version
MIMFOREGROUND="green"
export MIMFOREGROUND

# Background color for console version
MIMBACKGROUND="black"
export MIMBACKGROUND

# See colors names in /usr/X11R6/lib/X11/rgb.txt
# Foreground color for X11 version
XMIMFOREGROUND="black"
export XMIMFOREGROUND

# Background color for X11 version
XMIMBACKGROUND="gray"
export XMIMBACKGROUND

# Font for X11 version
# For 1024x768 resolution
# XMIMFONT="-cronyx-courier-medium-r-normal-*-*-140-*-*-m-*-koi8-r"
# For 800x600 resolution
# XMIMFONT="-cronyx-courier-medium-r-normal-*-*-120-*-*-m-*-koi8-r"
XMIMFONT="-misc-fixed-*-*-*-*-20-*-*-*-*-*-koi8-r"
export XMIMFONT

# Foreground color in status window for X11 version
XMIMSTFOREGROUND="white"
export XMIMSTFOREGROUND

# Background color in status window for X11 version
XMIMSTBACKGROUND="DarkSlateBlue"
export XMIMSTBACKGROUND

# Preffered shell
# For /bin/bash PS1 ignored
#MIMSHELL=/bin/bash
MIMSHELL=sh
export MIMSHELL

# Set mim as default editor
EDITOR=mim
export EDITOR
