#include "cmn.h"
#include "kbapcconsole.h"

#define MAXTABS 50
#define MAXLENTAB 200
#define FILE_NAME "apcconsole.cm"
short origin_table[] = {

LE_RIGHT   ,RIGHT,             -1,/*  0401    */
LE_LEFT    ,LEFT,              -1,/*  0402    */
LE_DEOL    ,CTRL_D,            -1,/*  0403       */
LE_DBGOL   ,CTRL_U,            -1,/*  0404       */
LE_BEG     ,Insert,LEFT,       -1,/*  0405      */
LE_END     ,Insert,RIGHT,      -1,/*  0406      */
LE_IC      ,N9,                -1,/*  0407    */
LE_DC      ,N8,                -1,/*  0410      */
LE_BS      ,ZB,                -1,/*  0411       */
LE_TAB     ,Tab,               -1,/*  0412       */
LE_LTAB    ,                   -1,/*  0413      */
LE_NWORD   ,                   -1,/*  0414    */
LE_PWORD   ,                   -1,/*  0415    */
LE_CCHAR   ,N0,                -1,/*  0416      */
LE_CDCHAR  ,Insert,N0,            -1,/*  0417      */
LE_PCHAR   ,DOT,               -1,/*  0420     */
LE_CCCHR   ,Insert,DOT,           -1,/*  0421     */
LE_CWORD   ,ESC,N0,            -1,/*  0422    */
LE_CDWORD  ,ESC,Insert,N0,        -1,/*  0423      */
LE_DWORD   ,CTRL_A,            -1,/*  0424        */
LE_DLWORD  ,ESC,CTRL_A,        -1,/*  0425     */
LE_CENTR   ,CTRL_T,            -1,/*  0426    */

LE_RINS    ,Insert,N9,            -1,/*  0427     */
LE_RREP    ,Insert,N8,            -1,/*  0430     */
LE_CCUP    ,Remove ,UP,        -1,/*  0431    ->  */
LE_CCDWN   ,Remove ,DOWN,      -1,/*  0432    ->  */
LE_CCRUS   ,Remove ,RIGHT,     -1,/*  0433    ->  */
LE_CCLAT   ,Remove ,LEFT,      -1,/*  0434    ->  */
LE_CATTR   ,Remove ,Enter,     -1,/*  0435    ->   */
LE_SPCHAR  ,                   -1,/*  0436     <> */
LE_ESCCHR  ,                   -1,/*  0437  ESC (033 ) */
LE_HFCHAR  ,MINUS,             -1,/*  0440    (0???) */

LA_NONE    ,F10,' ',           -1,/*  0441    :=  */
LA_LIGHT   ,F10,'S',           -1,/*  0442    ^=   */
LA_LIGHT   ,F10,'s',           -1,/*  0442    ^=   */
LA_ITALIC  ,F10,'M',           -1,/*  0443    ^=    */
LA_ITALIC  ,F10,'m',           -1,/*  0443    ^=    */
LA_UNDERL  ,F10,'P',           -1,/*  0444    ^=  */
LA_UNDERL  ,F10,'p',           -1,/*  0444    ^=  */
LA_BOLD    ,F10,'V',           -1,/*  0445    ^=   */
LA_BOLD    ,F10,'v',           -1,/*  0445    ^=   */
LA_SUPER   ,F10,'W',           -1,/*  0446    ^=   */
LA_SUPER   ,F10,'w',           -1,/*  0446    ^=   */
LA_SUBSCR  ,F10,'N',           -1,/*  0447    ^=   */
LA_SUBSCR  ,F10,'n',           -1,/*  0447    ^=   */
LA_INVERT  ,F10,'I',           -1,/*  0450    ^=  */
LA_INVERT  ,F10,'i',           -1,/*  0450    ^=  */

TE_UNDO    ,ALT_ZB,            -1,/*  0451   */
TE_UNUNDO  ,ESC,ALT_ZB,        -1,/*  0452    */
TE_UNUNDO  ,CTRL_ZB,           -1,/*  0452    */

TE_SRO     ,Insert, CTRL_T,       -1,/*  0455      */
TE_SRW     ,Insert, CTRL_E,       -1,/*  0456      */
TE_SWIGHT  ,Insert, CTRL_W,       -1,/*  0457     */

TE_SMARK   ,Insert,Return ,       -1,/*  0460    */
TE_CMARK   ,Insert,Tab,           -1,/*  0461      */

TE_PTAB    ,ESC,Tab,           -1,/*  0462     */
TE_PFORM   ,ESC,F9,            -1,/*  0463     */

TE_UP      ,UP,                -1,/*  0464    */
TE_DOWN    ,DOWN,              -1,/*  0465    */
TE_CUP     ,Insert, UP,           -1,/*  0466    */
TE_CDOWN   ,Insert, DOWN,         -1,/*  0467    */
TE_TBEG    ,PF1, UP,           -1,/*  0470     */
TE_TBEG    ,PF1, PrevScreen,   -1,/*  0470     */
TE_TEND    ,PF1, DOWN,         -1,/*  0471     */
TE_TEND    ,PF1, NextScreen,   -1,/*  0471     */

TE_IL      ,N6,                -1,/*  0472    */
TE_DL      ,N5,                -1,/*  0473    */
TE_CR      ,Return ,           -1,/*  0474      */
TE_RCR     ,ESC,Return,        -1,/*  0475      */
TE_SENTR   ,Insert,N7,            -1,/*  0476      .  */
TE_SENTR   ,Insert,Find,          -1,/*  0476      .  */
TE_SUP     ,ESC,N7,            -1,/*  0477    */
TE_SUP     ,ESC,Find,          -1,/*  0477    */
TE_SDOWN   ,N7,                -1,/*  0500    */
TE_SDOWN   ,Find,              -1,/*  0500    */
TE_CENTR   ,CTRL_E,            -1,/*  0501       */
TE_CLIN    ,N2,                -1,/*  0502      */
TE_CDLIN   ,Insert,N2,            -1,/*  0503      */
TE_PLIN    ,N3,                -1,/*  0504     */
TE_CCLIN   ,Insert,N3,            -1,/*  0505     */
TE_BLIN    ,Insert,N6,            -1,/*  0506      */
TE_SLIN    ,ESC,N6,            -1,/*  0507     */
TE_NBLIN   ,Insert,N5,            -1,/*  0510    */
TE_NSLIN   ,ESC,N5,            -1,/*  0511     */
TE_IPAGE   ,                   -1,/*  0512     */
TE_NPAGE   ,NextScreen,        -1,/*  0513     */
TE_PPAGE   ,PrevScreen,        -1,/*  0514     */

TE_MCBLOCK ,Select,            -1,/*  0515    /  */
TE_CDBLOCK ,Insert, Select,       -1,/*  0516      */
TE_CCBLOCK ,ESC, Select,       -1,/*  0517      */
TE_PBLOCK  ,PF1,Select,        -1,/*  0520    */
TE_PRBLOCK ,PF1,ESC,Select,    -1,/*  0521       */
TE_PIBLOCK ,PF1,Insert,Select,    -1,/*  0522    */
TE_PIRBLOCK,                   -1,/*  0523       */
TE_BLKEXEC ,PF1,Enter,         -1,/*  1021 */
TE_BLKMOD  ,Remove ,Select,    -1,/*  ???? */

TE_LPRINT  ,                   -1,/*  0524    */
TE_FPRINT  ,                   -1,/*  0525      */
TE_FORMAT  ,F9,                -1,/*  0526       */
TE_PFORMAT ,Insert,F9,            -1,/*  0527      */
TE_LDUP    ,F8, UP,            -1,/*  0530     */
TE_LDDOWN  ,F8, DOWN,          -1,/*  0531     */
TE_LDLEFT  ,F8, LEFT,          -1,/*  0532     */
TE_LDRIGHT ,F8, RIGHT,         -1,/*  0533     */
TE_RUP     ,ESC,PF1,N7,        -1,/*  0534      */
TE_RUP     ,ESC,PF1,Find,      -1,/*  0534      */
TE_RDOWN   ,PF1,N7,            -1,/*  0535      */
TE_RDOWN   ,PF1,Find,          -1,/*  0535      */

TE_PPRINT  ,                   -1,/*  0536  c   */
TE_IPRINT  ,                   -1,/*  0537  (  */
TE_RSPELL  ,                   -1,/*  0540  /  */
TE_LSPELL  ,                   -1,/*  0541 */
TE_SPADD   ,                   -1,/*  0542  $    */
TE_SPREM   ,                   -1,/*  0543     */

TE_HELP    ,ESC ,'/',          -1,/*  0544  help */
TE_HELP    ,ESC ,'?',          -1,/*  0544  help */
TE_HELP    ,Help,              -1,/*  0544  help */
TE_OHELP   ,ESC ,'H',          -1,/*  0544  help */
TE_OHELP   ,ESC ,'h',          -1,/*  0544  help */
TE_MSGS    ,ESC ,'!',          -1,/* 01013     */
TE_FENTR   ,ESC ,DOWN,         -1,/*  0545      */
TE_F2ENTR  ,ESC ,ESC ,         -1,/*  0546         */
TE_FEXEC   ,ESC,Enter,         -1,/*  0547    */
TE_EXEC    ,Insert,Enter,         -1,/*  0547    */
TE_SHELL   ,Enter,             -1,/*  0550      cli */
TE_INFILE  ,ESC,RIGHT,         -1,/*  0551  enter filename */
TE_OUTFILE ,ESC,LEFT,          -1,/*  0552  leave filename */

TE_MODFILE ,ESC,CTRL_U,        -1,

TE_UPDATE  ,ESC,Insert,           -1,/*  0553      */
TE_EXIT    ,ESC,UP,            -1,/*  0554       */
TE_EXOLD   ,ESC,CTRL_C,        -1,/*  0555       */
TE_EXBACK  ,ESC,ZB,            -1,/*  0556         */
TE_QUIT    ,PF1,PF1,           -1,/*  0557      */
TE_CRASH   ,CTRL_Y,            -1,/*  0557      */
TE_NERROR  ,F10, DOWN,         -1,/*  0560      */
TE_PERROR  ,F10, UP,           -1,/*  0561     */
TE_ERROFF  ,F10, F10,          -1,/* 01022     */
TE_STATUS  ,F7,                -1,/* 01023     */
TE_ZOOM    ,F11,               -1,/* 01024     */
TE_UFORK   ,ESC,PF4,UP,        -1,/*  0562   fork     */
TE_DFORK   ,ESC,PF4,DOWN,      -1,/* 01003   fork      */
TE_RFORK   ,ESC,PF4,RIGHT,     -1,/* 01004     fork      */
TE_LFORK   ,ESC,PF4,LEFT,      -1,/*  0563     fork       */
TE_UWINDOW ,PF4,UP,            -1,/*  0564     */
TE_DWINDOW ,PF4,DOWN,          -1,/*  0565      */
TE_RWINDOW ,PF4,RIGHT,         -1,/*  0566      */
TE_LWINDOW ,PF4,LEFT,          -1,/*  0567       */

TK_BREAK   ,CTRL_C,            -1,/*  0570       */
TK_CTRLO   ,CTRL_Z,            -1,/*  0571  /    */
TK_REPEAT  ,Insert ,Insert ,         -1,/*  0573  /   */
TK_BRUS    ,                   -1,/*  0574  /   */
TK_SRUS    ,CTRL_O,            -1,/*  0575  a    */
TK_BLAT    ,                   -1,/*  0576  /   */
TK_SLAT    ,CTRL_N,            -1,/*  0577  a    */
TK_SM+0    ,Insert ,N4,           -1,/*  0600     0 */
TK_EM+0    ,N4,                -1,/*  0700   /  0 */
TK_SM+1    ,Insert,PF1,'1',       -1,/*  0600     0 */
TK_EM+1    ,    PF1,'1',       -1,/*  0700   /  0 */
TK_SM+2    ,Insert,PF1,'2',       -1,/*  0600     0 */
TK_EM+2    ,    PF1,'2',       -1,/*  0700   /  0 */
TK_SM+3    ,Insert,PF1,'3',       -1,/*  0600     0 */
TK_EM+3    ,    PF1,'3',       -1,/*  0700   /  0 */
TK_SM+4    ,Insert,PF1,'4',       -1,/*  0600     0 */
TK_EM+4    ,    PF1,'4',       -1,/*  0700   /  0 */
TK_SM+5    ,Insert,PF1,'5',       -1,/*  0600     0 */
TK_EM+5    ,    PF1,'5',       -1,/*  0700   /  0 */
TK_SM+6    ,Insert,PF1,'6',       -1,/*  0600     0 */
TK_EM+6    ,    PF1,'6',       -1,/*  0700   /  0 */
TK_SM+7    ,Insert,PF1,'7',       -1,/*  0600     0 */
TK_EM+7    ,    PF1,'7',       -1,/*  0700   /  0 */
TK_SM+8    ,Insert,PF1,'8',       -1,/*  0600     0 */
TK_EM+8    ,    PF1,'8',       -1,/*  0700   /  0 */
TK_SM+9    ,Insert,PF1,'9',       -1,/*  0600     0 */
TK_EM+9    ,    PF1,'9',       -1,/*  0700   /  0 */
TK_SM+10   ,Insert,PF1,'0',       -1,/*  0600     0 */
TK_EM+10   ,    PF1,'0',       -1,/*  0700   /  0 */
TK_SM+11   ,                   -1,/*  0600     0 */
TK_EM+11   ,                   -1,/*  0700   /  0 */

TD_SDEQ    ,PF1,'D',           -1,/*  01001* /  */
TD_SDEQ    ,PF1,'d',           -1,/*  01001* /  */
TD_STXT    ,                   -1,/*  01002* /  */
TK_CSET    ,PF1,N2,            -1,
TK_CADD    ,PF1,N9,            -1,
TK_CSUB    ,PF1,N8,            -1,
TK_CPUT    ,PF1,N3,            -1,
TK_DATE    ,PF1,CTRL_D,        -1,/*  01005  "   */
TK_TIME    ,PF1,CTRL_T,        -1,/*  01006  "   */
MC_SAVE    ,COMMA,COMMA,N0,    -1,/*  01007  "    */
MC_LOAD    ,COMMA,COMMA,DOT,   -1,/*  01010  '    */
MC_2SAVE   ,COMMA,N0,          -1,/*  01011  "    */
MC_2LOAD   ,COMMA,DOT,         -1,/*  01012  '    */
-1};

short special_table[] = {

TK_ESC     ,ESC,               /*  0572  Esc */
-1};

#include "gentab.c"
