#include "cmn.h"
#include "kbpca-ANSI.h"

#define MAXTABS 50
#define MAXLENTAB 200
#define FILE_NAME "pca-ANSI.cm"

short origin_table[] = {

LE_RIGHT   ,RIGHT,             -1,/*  0401    */
LE_LEFT    ,LEFT,              -1,/*  0402    */
LE_DEOL    ,CTRL_D,            -1,/*  0403       */
LE_DBGOL   ,CTRL_U,            -1,/*  0404       */
LE_BEG     ,Home, LEFT,        -1,/*  0405      */
LE_END     ,Home, RIGHT,       -1,/*  0406      */
LE_IC      ,Insert,            -1,/*  0407    */
LE_DC      ,Delete,            -1,/*  0410      */
LE_BS      ,ZB,                -1,/*  0411       */
LE_TAB     ,Tab,               -1,/*  0412       */
LE_LTAB    ,                   -1,/*  0413      */
LE_NWORD   ,                   -1,/*  0414    */
LE_PWORD   ,                   -1,/*  0415    */
LE_CCHAR   ,F1,                -1,/*  0416      */
LE_CDCHAR  ,SHIFT_F1,          -1,/*  0417      */
LE_PCHAR   ,F2,                -1,/*  0420     */
LE_CCCHR   ,SHIFT_F2,          -1,/*  0421     */
LE_CWORD   ,Home, F1,          -1,/*  0422    */
LE_CDWORD  ,Home, SHIFT_F1,    -1,/*  0423      */
LE_DWORD   ,CTRL_A,            -1,/*  0424        */
LE_DLWORD  ,Home,CTRL_A,       -1,/*  0425     */
LE_CENTR   ,CTRL_T,            -1,/*  0426    */

LE_RINS    ,ESC, Insert,       -1,/*  0427     */
LE_RREP    ,ESC, Delete,       -1,/*  0430     */
LE_CCUP    ,                   -1,/*  0431    ->  */
LE_CCDWN   ,                   -1,/*  0432    ->  */
LE_CCRUS   ,                   -1,/*  0433    ->  */
LE_CCLAT   ,                   -1,/*  0434    ->  */
LE_CATTR   ,                   -1,/*  0435    ->   */
LE_SPCHAR  ,CTRL_X,            -1,/*  0436     <> */
LE_ESCCHR  ,                   -1,/*  0437  ESC (033 ) */
LE_HFCHAR  ,                   -1,/*  0440           */

LA_NONE    ,F10,' ',           -1,/*  0441    :=  */
LA_LIGHT   ,F10,'S',           -1,/*  0442    ^=   */
LA_LIGHT   ,F10,'s',           -1,/*  0442    ^=   */
LA_ITALIC  ,F10,'M',           -1,/*  0443    ^=    */
LA_ITALIC  ,F10,'m',           -1,/*  0443    ^=    */
LA_UNDERL  ,F10,'P',           -1,/*  0444    ^=  */
LA_UNDERL  ,F10,'p',           -1,/*  0444    ^=  */
LA_BOLD    ,F10,'V',           -1,/*  0445    ^=   */
LA_BOLD    ,F10,'v',           -1,/*  0445    ^=   */
LA_SUPER   ,F10,'W',           -1,/*  0446    ^=   */
LA_SUPER   ,F10,'w',           -1,/*  0446    ^=   */
LA_SUBSCR  ,F10,'N',           -1,/*  0447    ^=   */
LA_SUBSCR  ,F10,'n',           -1,/*  0447    ^=   */
LA_INVERT  ,F10,'I',           -1,/*  0450    ^=  */
LA_INVERT  ,F10,'i',         -1,/*  0450    ^=  */

TE_UNDO    ,F8,                -1,/*  0451   */
TE_UNUNDO  ,SHIFT_F8,          -1,/*  0452    */
TE_UNUNDO  ,Home, F8,          -1,/*  0452    */
TE_SUNDO   ,                   -1,/*  0453   */
TE_SUNUNDO ,                   -1,/*  0454    */

TE_SRO     ,Home,CTRL_T,       -1,/*  0455      */
TE_SRW     ,Home,CTRL_E,       -1,/*  0456      */
TE_SWIGHT  ,Home,CTRL_W,       -1,/*  0457     */

TE_SMARK   ,                   -1,/*  0460    */
TE_CMARK   ,                   -1,/*  0461      */

TE_PTAB    ,ESC,  Tab,         -1,/*  0462     */
TE_PFORM   ,ESC,  F9,          -1,/*  0463     */

TE_UP      ,UP,                -1,/*  0464    */
TE_DOWN    ,DOWN,              -1,/*  0465    */
TE_CUP     ,Home,UP,           -1,/*  0466    */
TE_CDOWN   ,Home,DOWN,         -1,/*  0467    */
TE_TBEG    ,                   -1,/*  0470     */
TE_TEND    ,                   -1,/*  0471     */

TE_IL      ,Home, Insert,      -1,/*  0472    */
TE_DL      ,Home, Delete,      -1,/*  0473    */
TE_CR      ,Enter,             -1,/*  0474      */
TE_RCR     ,                   -1,/*  0475      */
TE_SENTR   ,Home, F7,          -1,/*  0476      .  */
TE_SUP     ,SHIFT_F7,          -1,/*  0477    */
TE_SDOWN   ,F7,                -1,/*  0500    */
TE_CENTR   ,CTRL_E,            -1,/*  0501       */
TE_CLIN    ,F3,                -1,/*  0502      */
TE_CDLIN   ,SHIFT_F3,          -1,/*  0503      */
TE_PLIN    ,F4,                -1,/*  0504     */
TE_CCLIN   ,SHIFT_F4,          -1,/*  0505     */

TE_BLIN    ,                   -1,/*  0506      */
TE_SLIN    ,                   -1,/*  0507     */
TE_NBLIN   ,                   -1,/*  0510    */
TE_NSLIN   ,                   -1,/*  0511     */
TE_IPAGE   ,                   -1,/*  0512     */
TE_NPAGE   ,                   -1,/*  0513     */
TE_PPAGE   ,                   -1,/*  0514     */

TE_MCBLOCK ,                   -1,/*  0515    /  */
TE_CDBLOCK ,                   -1,/*  0516      */
TE_CCBLOCK ,                   -1,/*  0517      */
TE_PBLOCK  ,                   -1,/*  0520    */
TE_PRBLOCK ,                   -1,/*  0521       */
TE_PIBLOCK ,                   -1,/*  0522    */
TE_PIRBLOCK,                   -1,/*  0523       */
TE_BLKEXEC ,                   -1,/*  1021 */
TE_BLKMOD  ,                   -1,/*  ???? */

TE_LPRINT  ,                   -1,/*  0524    */
TE_FPRINT  ,                   -1,/*  0525      */
TE_FORMAT  ,F9,                -1,/*  0526       */
TE_PFORMAT ,SHIFT_F9,          -1,/*  0527      */
TE_LDUP    ,                   -1,/*  0530     */
TE_LDDOWN  ,                   -1,/*  0531     */
TE_LDLEFT  ,                   -1,/*  0532     */
TE_LDRIGHT ,                   -1,/*  0533     */
TE_RUP     ,ESC, SHIFT_F7,     -1,/*  0534      */
TE_RDOWN   ,ESC, F7,           -1,/*  0535      */

TE_PPRINT  ,                   -1,/*  0536  c   */
TE_IPRINT  ,                   -1,/*  0537  (  */
TE_RSPELL  ,                   -1,/*  0540  /  */
TE_LSPELL  ,                   -1,/*  0541 */
TE_SPADD   ,                   -1,/*  0542  $    */
TE_SPREM   ,                   -1,/*  0543     */

TE_HELP    ,ESC ,'/',          -1,/*  0544  help */
TE_HELP    ,ESC ,'?',          -1,/*  0544  help */
TE_OHELP   ,ESC ,'H',          -1,/*  0544  help */
TE_OHELP   ,ESC ,'h',          -1,/*  0544  help */
TE_MSGS    ,ESC ,'!',          -1,/* 01013     */
TE_FENTR   ,ESC ,DOWN,         -1,/*  0545      */
TE_F2ENTR  ,ESC ,ESC ,         -1,/*  0546         */
TE_FEXEC   ,                   -1,/*  0547    */
TE_EXEC    ,                   -1,/*  0547    */
TE_SHELL   ,                   -1,/*  0550      cli */
TE_INFILE  ,ESC,RIGHT,         -1,/*  0551  enter filename */
TE_OUTFILE ,ESC,LEFT,          -1,/*  0552  leave filename */

TE_MODFILE ,ESC,CTRL_U,        -1,

TE_UPDATE  ,Home, ESC,         -1,/*  0553      */
TE_EXIT    ,ESC,UP,            -1,/*  0554       */
TE_EXOLD   ,ESC,CTRL_C,        -1,/*  0555       */
TE_EXBACK  ,ESC,ZB,            -1,/*  0556         */
TE_QUIT    ,                   -1,/*  0557      */
TE_CRASH   ,                   -1,/*  0557      */
TE_NERROR  ,                   -1,/*  0560      */
TE_PERROR  ,                   -1,/*  0561     */
TE_ERROFF  ,                   -1,/* 01022     */
TE_STATUS  ,                   -1,/* 01023     */
TE_ZOOM    ,                   -1,/* 01024     */
TE_UFORK   ,                   -1,/*  0562   fork     */
TE_DFORK   ,                   -1,/* 01003   fork      */
TE_RFORK   ,                   -1,/* 01004     fork      */
TE_LFORK   ,                   -1,/*  0563     fork       */
TE_UWINDOW ,                   -1,/*  0564     */
TE_DWINDOW ,                   -1,/*  0565      */
TE_RWINDOW ,                   -1,/*  0566      */
TE_LWINDOW ,                   -1,/*  0567       */

TK_BREAK   ,CTRL_C,            -1,/*  0570       */
TK_CTRLO   ,CTRL_Z,            -1,/*  0571  /    */
TK_REPEAT  ,Home, Home,        -1,/*  0573  /   */
TK_BRUS    ,                   -1,/*  0574  /   */
TK_SRUS    ,CTRL_O,            -1,/*  0575  a    */
TK_BLAT    ,                   -1,/*  0576  /   */
TK_SLAT    ,CTRL_N,            -1,/*  0577  a    */
TK_SM+0    ,                   -1,/*  0600     0 */
TK_EM+0    ,                   -1,/*  0700   /  0 */
TK_SM+1    ,                   -1,/*  0600     0 */
TK_EM+1    ,                   -1,/*  0700   /  0 */
TK_SM+2    ,                   -1,/*  0600     0 */
TK_EM+2    ,                   -1,/*  0700   /  0 */
TK_SM+3    ,                   -1,/*  0600     0 */
TK_EM+3    ,                   -1,/*  0700   /  0 */
TK_SM+4    ,                   -1,/*  0600     0 */
TK_EM+4    ,                   -1,/*  0700   /  0 */
TK_SM+5    ,                   -1,/*  0600     0 */
TK_EM+5    ,                   -1,/*  0700   /  0 */
TK_SM+6    ,                   -1,/*  0600     0 */
TK_EM+6    ,                   -1,/*  0700   /  0 */
TK_SM+7    ,                   -1,/*  0600     0 */
TK_EM+7    ,                   -1,/*  0700   /  0 */
TK_SM+8    ,                   -1,/*  0600     0 */
TK_EM+8    ,                   -1,/*  0700   /  0 */
TK_SM+9    ,                   -1,/*  0600     0 */
TK_EM+9    ,                   -1,/*  0700   /  0 */
TK_SM+10   ,                   -1,/*  0600     0 */
TK_EM+10   ,                   -1,/*  0700   /  0 */
TK_SM+11   ,                   -1,/*  0600     0 */
TK_EM+11   ,                   -1,/*  0700   /  0 */

TD_SDEQ    ,                   -1,/*  01001* /  */
TD_SDEQ    ,                   -1,/*  01001* /  */
TD_STXT    ,                   -1,/*  01002* /  */
TK_CSET    ,                   -1,
TK_CADD    ,                   -1,
TK_CSUB    ,                   -1,
TK_CPUT    ,                   -1,
TK_DATE    ,Home, CTRL_D,      -1,/*  01005  "   */
TK_TIME    ,Home, CTRL_V,      -1,/*  01006  "   */
MC_SAVE    ,                   -1,/*  01007  "    */
MC_LOAD    ,                   -1,/*  01010  '    */
MC_2SAVE   ,                   -1,/*  01011  "    */
MC_2LOAD   ,                   -1,/*  01012  '    */

EX_EXEC    ,                   -1,/*  02030  '    */
EX_CEXEC   ,                   -1,/*  02031  '    */
EX_FEXEC   ,                   -1,/*  02032  '    */

MC_INCL    ,                   -1,/*  02000  '    */
MC_INCL    ,                   -1,/*  02000  '    */
MC_PROC    ,                   -1,/*  02000  '    */
MC_PROC    ,                   -1,/*  02000  '    */
MC_SUBR    ,                   -1,/*  02000  '    */
MC_SUBR    ,                   -1,/*  02000  '    */
MC_FUNC    ,                   -1,/*  02000  '    */
MC_FUNC    ,                   -1,/*  02000  '    */
MC_WHIL    ,                   -1,/*  02000  '    */
MC_WHIL    ,                   -1,/*  02000  '    */
MC_DO      ,                   -1,/*  02000  '    */
MC_DO      ,                   -1,/*  02000  '    */
MC_IF      ,                   -1,/*  02000  '    */
MC_IF      ,                   -1,/*  02000  '    */

DB_DUMP    ,                   -1,/*  02000  '    */
DB_DUMP    ,                   -1,/*  02000  '    */
DB_TRACE   ,                   -1,/*  02000  '    */
DB_TRACE   ,                   -1,/*  02000  '    */

-1};

short special_table[] = {

TK_ESC     ,ESC,               /*  0572  Esc */
-1};

#include "gentab.c"
