#include "cmn.h"
#include "kbtvt52.h"
#define MAXTABS 10
#define MAXLENTAB 200
#define FILE_NAME "tvt52.cm"
short origin_table[] = {
LE_RIGHT   ,RIGHT,             -1,/*  0401    */
LE_LEFT    ,LEFT,              -1,/*  0402    */
LE_DEOL    ,CTRL_D,            -1,/*  0403       */
LE_DBGOL   ,CTRL_U,            -1,/*  0404       */
LE_BEG     ,PF2,LEFT,          -1,/*  0405      */
LE_END     ,PF2,RIGHT,         -1,/*  0406      */
LE_IC      ,N9,                -1,/*  0407    */
LE_DC      ,N8,                -1,/*  0410      */
LE_BS      ,ZB,                -1,/*  0411       */
LE_TAB     ,Tab,               -1,/*  0412       */
LE_LTAB    ,                   -1,/*  0413      */
LE_NWORD   ,                   -1,/*  0414    */
LE_PWORD   ,                   -1,/*  0415    */
LE_CCHAR   ,N0,                -1,/*  0416      */
LE_CDCHAR  ,                   -1,/*  0417      */
LE_PCHAR   ,DOT,               -1,/*  0420     */
LE_CCCHR   ,PF2,DOT,           -1,/*  0421     */
LE_CWORD   ,PF2,N0,            -1,/*  0422    */
LE_CDWORD  ,                   -1,/*  0423      */
LE_DWORD   ,N1,                -1,/*  0424        */
LE_DLWORD  ,                   -1,/*  0425     */
LE_CENTR   ,CTRL_T,            -1,/*  0426    */
LE_RINS    ,PF2,N9,            -1,/*  0427     */
LE_RREP    ,PF2,N8,            -1,/*  0430     */
LE_CCUP    ,                   -1,/*  0431    ->  */
LE_CCDWN   ,                   -1,/*  0432    ->  */
LE_CCRUS   ,                   -1,/*  0433    ->  */
LE_CCLAT   ,                   -1,/*  0434    ->  */
LE_CATTR   ,                   -1,/*  0435    ->   */
LE_SPCHAR  ,                   -1,/*  0436     <> */
LE_ESCCHR  ,                   -1,/*  0437  ESC (033 ) */
LE_HFCHAR  ,                   -1,/*  0440    (0???) */
LA_NONE    ,                   -1,/*  0441    :=  */
LA_LIGHT   ,                   -1,/*  0442    ^=   */
LA_ITALIC  ,                   -1,/*  0443    ^=    */
LA_UNDERL  ,                   -1,/*  0444    ^=  */
LA_BOLD    ,                   -1,/*  0445    ^=   */
LA_SUPER   ,                   -1,/*  0446    ^=   */
LA_SUBSCR  ,                   -1,/*  0447    ^=   */
LA_INVERT  ,                   -1,/*  0450    ^=  */
TE_UNDO    ,PF2,F12,           -1,/*  0451   */
TE_UNUNDO  ,PF2,NewLine,       -1,/*  0452    */
TE_SUNDO   ,                   -1,/*  0453   */
TE_SUNUNDO ,                   -1,/*  0454    */
TE_SRO     ,PF2, CTRL_T,       -1,/*  0455      */
TE_SRW     ,PF2, CTRL_E,       -1,/*  0456      */
TE_SWIGHT  ,                   -1,/*  0457     */
TE_SMARK   ,PF2,CTRL_J,        -1,/*  0460    */
TE_CMARK   ,PF2,Tab,           -1,/*  0461      */
TE_PTAB    ,PF3,Tab,           -1,/*  0462     */
TE_PFORM   ,PF3,N1,            -1,/*  0463     */
TE_UP      ,UP,                -1,/*  0464    */
TE_DOWN    ,DOWN,              -1,/*  0465    */
TE_CUP     ,PF2, UP,           -1,/*  0466    */
TE_CDOWN   ,PF2, DOWN,         -1,/*  0467    */
TE_TBEG    ,PF1, UP,           -1,/*  0470     */
TE_TEND    ,PF1, DOWN,         -1,/*  0471     */
TE_IL      ,N6,                -1,/*  0472    */
TE_DL      ,N5,                -1,/*  0473    */
TE_CR      ,NewLine,           -1,/*  0474      */
TE_RCR     ,F12,               -1,/*  0475      */
TE_SENTR   ,PF2,N7,            -1,/*  0476      .  */
TE_SUP     ,PF3,N7,            -1,/*  0477    */
TE_SDOWN   ,N7,                -1,/*  0500    */
TE_CENTR   ,CTRL_E,            -1,/*  0501       */
TE_CLIN    ,N2,                -1,/*  0502      */
TE_CDLIN   ,PF2,N2,            -1,/*  0503      */
TE_PLIN    ,N3,                -1,/*  0504     */
TE_CCLIN   ,PF2,N3,            -1,/*  0505     */
TE_BLIN    ,PF2,N6,            -1,/*  0506      */
TE_SLIN    ,PF3,N6,            -1,/*  0507     */
TE_NBLIN   ,PF2,N5,            -1,/*  0510    */
TE_NSLIN   ,PF3,N5,            -1,/*  0511     */
TE_IPAGE   ,                   -1,/*  0512     */
TE_NPAGE   ,                   -1,/*  0513     */
TE_PPAGE   ,                   -1,/*  0514     */
TE_MCBLOCK ,                   -1,/*  0515    /  */
TE_CDBLOCK ,                   -1,/*  0516      */
TE_CCBLOCK ,                   -1,/*  0517      */
TE_PBLOCK  ,                   -1,/*  0520    */
TE_PRBLOCK ,                   -1,/*  0521       */
TE_PIBLOCK ,                   -1,/*  0522    */
TE_PIRBLOCK,                   -1,/*  0523       */
TE_LPRINT  ,                   -1,/*  0524    */
TE_FPRINT  ,                   -1,/*  0525      */
TE_FORMAT  ,                   -1,/*  0526       */
TE_PFORMAT ,PF2,N1,            -1,/*  0527      */
TE_LDUP    ,                   -1,/*  0530     */
TE_LDDOWN  ,                   -1,/*  0531     */
TE_LDLEFT  ,                   -1,/*  0532     */
TE_LDRIGHT ,                   -1,/*  0533     */
TE_RUP     ,PF3,PF1,N7,        -1,/*  0534      */
TE_RDOWN   ,PF1,N7,            -1,/*  0535      */
TE_PPRINT  ,                   -1,/*  0536  c   */
TE_IPRINT  ,                   -1,/*  0537  (  */
TE_RSPELL  ,                   -1,/*  0540  /  */
TE_LSPELL  ,                   -1,/*  0541 */
TE_SPADD   ,                   -1,/*  0542  $    */
TE_SPREM   ,                   -1,/*  0543     */
TE_HELP    ,PF3 ,'/',          -1,/*  0544  help */
TE_HELP    ,PF3 ,'?',          -1,/*  0544  help */
TE_MSGS    ,PF3 ,'!',          -1,/* 01013     */
TE_FENTR   ,PF3 ,DOWN,         -1,/*  0545      */
TE_F2ENTR  ,PF3 ,PF3 ,         -1,/*  0546         */
TE_FEXEC   ,PF3,Enter,         -1,/*  0547    */
TE_EXEC    ,PF2,Enter,         -1,/*  0547    */
TE_SHELL   ,Enter,             -1,/*  0550      cli */
TE_INFILE  ,PF3,RIGHT,         -1,/*  0551  enter filename */
TE_OUTFILE ,PF3,LEFT,          -1,/*  0552  leave filename */
TE_MODFILE ,PF3,CTRL_U,        -1,
TE_UPDATE  ,PF2,PF3,           -1,/*  0553      */
TE_EXIT    ,PF3,UP,            -1,/*  0554       */
TE_EXOLD   ,PF3,CTRL_C,        -1,/*  0555       */
TE_EXBACK  ,PF3,ZB,            -1,/*  0556         */
TE_QUIT    ,PF1,PF1,           -1,/*  0557      */
TE_NERROR  ,                   -1,/*  0560      */
TE_PERROR  ,                   -1,/*  0561     */
TE_UFORK   ,PF3,PF4,UP,        -1,/*  0562   fork     */
TE_DFORK   ,PF3,PF4,DOWN,      -1,/* 01003   fork      */
TE_RFORK   ,PF3,PF4,RIGHT,     -1,/* 01004     fork      */
TE_LFORK   ,PF3,PF4,LEFT,      -1,/*  0563     fork       */
TE_UWINDOW ,PF4,UP,            -1,/*  0564     */
TE_DWINDOW ,PF4,DOWN,          -1,/*  0565      */
TE_RWINDOW ,PF4,RIGHT,         -1,/*  0566      */
TE_LWINDOW ,PF4,LEFT,          -1,/*  0567       */
TK_BREAK   ,CTRL_C,            -1,/*  0570       */
TK_CTRLO   ,CTRL_Z,            -1,/*  0571  /    */
TK_REPEAT  ,PF2 ,PF2 ,         -1,/*  0573  /   */
TK_BRUS    ,                   -1,/*  0574  /   */
TK_SRUS    ,                   -1,/*  0575  a    */
TK_BLAT    ,                   -1,/*  0576  /   */
TK_SLAT    ,                   -1,/*  0577  a    */
TK_SM+0    ,PF2 ,N4,           -1,/*  0600     0 */
TK_EM+0    ,N4,                -1,/*  0700   /  0 */
TK_SM+1    ,                   -1,/*  0600     0 */
TK_EM+1    ,                   -1,/*  0700   /  0 */
TK_SM+2    ,                   -1,/*  0600     0 */
TK_EM+2    ,                   -1,/*  0700   /  0 */
TK_SM+3    ,                   -1,/*  0600     0 */
TK_EM+3    ,                   -1,/*  0700   /  0 */
TK_SM+4    ,                   -1,/*  0600     0 */
TK_EM+4    ,                   -1,/*  0700   /  0 */
TK_SM+5    ,                   -1,/*  0600     0 */
TK_EM+5    ,                   -1,/*  0700   /  0 */
TK_SM+6    ,                   -1,/*  0600     0 */
TK_EM+6    ,                   -1,/*  0700   /  0 */
TK_SM+7    ,                   -1,/*  0600     0 */
TK_EM+7    ,                   -1,/*  0700   /  0 */
TK_SM+8    ,                   -1,/*  0600     0 */
TK_EM+8    ,                   -1,/*  0700   /  0 */
TK_SM+9    ,                   -1,/*  0600     0 */
TK_EM+9    ,                   -1,/*  0700   /  0 */
TK_SM+10   ,                   -1,/*  0600     0 */
TK_EM+10   ,                   -1,/*  0700   /  0 */
TK_SM+11   ,                   -1,/*  0600     0 */
TK_EM+11   ,                   -1,/*  0700   /  0 */
TD_SDEQ    ,                   -1,/*  01001* /  */
TD_STXT    ,                   -1,/*  01002* /  */
TK_DATE    ,                   -1,/*  01005  "   */
TK_TIME    ,                   -1,/*  01006  "   */
MC_SAVE    ,COMMA,N8,          -1,/*  01007  "    */
MC_LOAD    ,COMMA,N9,          -1,/*  01010  '    */
MC_2SAVE   ,COMMA,COMMA,N8,    -1,/*  01011  "    */
MC_2LOAD   ,COMMA,COMMA,N9,    -1,/*  01012  '    */
-1};
short special_table[] = {
TK_ESC     ,F11,               /*  0572  Esc */
TK_ESC     ,PF3,               /*  0572  Esc */
-1};
#include "gentab.c"
