#include "cmn.h"
#include "kbxdecterm.h"

#define MAXTABS 50
#define MAXLENTAB 200
#define FILE_NAME "xdecterm.cm"

short origin_table[] = {

LE_RIGHT   ,RIGHT,             -1,/*  0401    */
LE_LEFT    ,LEFT,              -1,/*  0402    */
LE_DEOL    ,CTRL_D,            -1,/*  0403       */
LE_DBGOL   ,CTRL_U,            -1,/*  0404       */
LE_BEG     ,PF2,LEFT,          -1,/*  0405      */
LE_END     ,PF2,RIGHT,         -1,/*  0406      */
LE_IC      ,N9,                -1,/*  0407    */
LE_DC      ,N8,                -1,/*  0410      */
LE_BS      ,ZB,                -1,/*  0411       */
LE_TAB     ,Tab,               -1,/*  0412       */
LE_TAB     ,LE_TAB,            -1,/*  0412       */
LE_LTAB    ,CTRL_ZB,           -1,/*  0413      */
LE_NWORD   ,                   -1,/*  0414    */
LE_PWORD   ,                   -1,/*  0415    */
LE_CCHAR   ,N0,                -1,/*  0416      */
LE_CDCHAR  ,PF2,N0,            -1,/*  0417      */
LE_PCHAR   ,DOT,               -1,/*  0420     */
LE_CCCHR   ,PF2,DOT,           -1,/*  0421     */
LE_CWORD   ,PF3,N0,            -1,/*  0422    */
LE_CDWORD  ,PF3,PF2,N0,        -1,/*  0423      */
LE_DWORD   ,CTRL_A,            -1,/*  0424        */
LE_DLWORD  ,PF3,CTRL_A,        -1,/*  0425     */
LE_CENTR   ,CTRL_T,            -1,/*  0426    */

LE_RINS    ,PF2,N9,            -1,/*  0427     */
LE_RREP    ,PF2,N8,            -1,/*  0430     */
LE_CCUP    ,Remove ,UP,        -1,/*  0431    ->  */
LE_CCDWN   ,Remove ,DOWN,      -1,/*  0432    ->  */
LE_CCRUS   ,Remove ,RIGHT,     -1,/*  0433    ->  */
LE_CCLAT   ,Remove ,LEFT,      -1,/*  0434    ->  */
LE_CATTR   ,Remove ,Enter,     -1,/*  0435    ->   */
LE_SPCHAR  ,Insert,            -1,/*  0436     <> */
LE_ESCCHR  ,                   -1,/*  0437  ESC (033 ) */
LE_HFCHAR  ,MINUS,             -1,/*  0440    (0???) */

LA_NONE    ,F10,' ',           -1,/*  0441    :=  */
LA_LIGHT   ,F10,'S',           -1,/*  0442    ^=   */
LA_LIGHT   ,F10,'s',           -1,/*  0442    ^=   */
LA_ITALIC  ,F10,'M',           -1,/*  0443    ^=    */
LA_ITALIC  ,F10,'m',           -1,/*  0443    ^=    */
LA_UNDERL  ,F10,'P',           -1,/*  0444    ^=  */
LA_UNDERL  ,F10,'p',           -1,/*  0444    ^=  */
LA_BOLD    ,F10,'V',           -1,/*  0445    ^=   */
LA_BOLD    ,F10,'v',           -1,/*  0445    ^=   */
LA_SUPER   ,F10,'W',           -1,/*  0446    ^=   */
LA_SUPER   ,F10,'w',           -1,/*  0446    ^=   */
LA_SUBSCR  ,F10,'N',           -1,/*  0447    ^=   */
LA_SUBSCR  ,F10,'n',           -1,/*  0447    ^=   */
LA_INVERT  ,F10,'I',           -1,/*  0450    ^=  */
LA_INVERT  ,F10,'i',         -1,/*  0450    ^=  */

TE_UNDO    ,Do,                -1,/*  0451   */
TE_UNUNDO  ,PF3,Do,            -1,/*  0452    */
TE_SUNDO   ,PF1,Do,            -1,/*  0453   */
TE_SUNUNDO ,PF3,PF1,Do,        -1,/*  0454    */

TE_SRO     ,PF2, CTRL_T,       -1,/*  0455      */
TE_SRW     ,PF2, CTRL_E,       -1,/*  0456      */
TE_SWIGHT  ,PF2, CTRL_W,       -1,/*  0457     */

TE_SMARK   ,PF2,Return ,       -1,/*  0460    */
TE_CMARK   ,PF2,Tab,           -1,/*  0461      */

TE_PTAB    ,PF3,Tab,           -1,/*  0462     */
TE_PFORM   ,PF3,F9,            -1,/*  0463     */

TE_UP      ,UP,                -1,/*  0464    */
TE_DOWN    ,DOWN,              -1,/*  0465    */
TE_CUP     ,PF2, UP,           -1,/*  0466    */
TE_CDOWN   ,PF2, DOWN,         -1,/*  0467    */
TE_TBEG    ,PF1, UP,           -1,/*  0470     */
TE_TBEG    ,PF1, PrevScreen,   -1,/*  0470     */
TE_TEND    ,PF1, DOWN,         -1,/*  0471     */
TE_TEND    ,PF1, NextScreen,   -1,/*  0471     */

TE_IL      ,N6,                -1,/*  0472    */
TE_DL      ,N5,                -1,/*  0473    */
TE_CR      ,Return,            -1,/*  0474      */
TE_CR      ,TE_CR,             -1,/*  0474      */
TE_RCR     ,PF3,Return,        -1,/*  0475      */
TE_SENTR   ,PF2,N7,            -1,/*  0476      .  */
TE_SENTR   ,PF2,Find,          -1,/*  0476      .  */
TE_SUP     ,PF3,N7,            -1,/*  0477    */
TE_SUP     ,PF3,Find,          -1,/*  0477    */
TE_SDOWN   ,N7,                -1,/*  0500    */
TE_SDOWN   ,Find,              -1,/*  0500    */
TE_CENTR   ,CTRL_E,            -1,/*  0501       */
TE_CLIN    ,N2,                -1,/*  0502      */
TE_CDLIN   ,PF2,N2,            -1,/*  0503      */
TE_PLIN    ,N3,                -1,/*  0504     */
TE_CCLIN   ,PF2,N3,            -1,/*  0505     */
TE_BLIN    ,PF2,N6,            -1,/*  0506      */
TE_SLIN    ,PF3,N6,            -1,/*  0507     */
TE_NBLIN   ,PF2,N5,            -1,/*  0510    */
TE_NSLIN   ,PF3,N5,            -1,/*  0511     */
TE_IPAGE   ,                   -1,/*  0512     */
TE_NPAGE   ,NextScreen,        -1,/*  0513     */
TE_PPAGE   ,PrevScreen,        -1,/*  0514     */

TE_MCBLOCK ,Select,            -1,/*  0515    /  */
TE_CDBLOCK ,PF2, Select,       -1,/*  0516      */
TE_CCBLOCK ,PF3, Select,       -1,/*  0517      */
TE_PBLOCK  ,PF1,Select,        -1,/*  0520    */
TE_PRBLOCK ,PF1,PF3,Select,    -1,/*  0521       */
TE_PIBLOCK ,PF1,PF2,Select,    -1,/*  0522    */
TE_PIRBLOCK,PF1,PF2,PF3,Select,-1,/*  0523       */
TE_BLKEXEC ,PF1,Enter,         -1,/*  1021 */
TE_BLKMOD  ,Remove ,Select,    -1,/*  ???? */

TE_LPRINT  ,                   -1,/*  0524    */
TE_FPRINT  ,                   -1,/*  0525      */
TE_FORMAT  ,F9,                -1,/*  0526       */
TE_PFORMAT ,PF2,F9,            -1,/*  0527      */
TE_LDUP    ,F8, UP,            -1,/*  0530     */
TE_LDDOWN  ,F8, DOWN,          -1,/*  0531     */
TE_LDLEFT  ,F8, LEFT,          -1,/*  0532     */
TE_LDRIGHT ,F8, RIGHT,         -1,/*  0533     */
TE_RUP     ,PF3,PF1,N7,        -1,/*  0534      */
TE_RUP     ,PF3,PF1,Find,      -1,/*  0534      */
TE_RDOWN   ,PF1,N7,            -1,/*  0535      */
TE_RDOWN   ,PF1,Find,          -1,/*  0535      */

TE_PPRINT  ,                   -1,/*  0536  c   */
TE_IPRINT  ,                   -1,/*  0537  (  */
TE_RSPELL  ,                   -1,/*  0540  /  */
TE_LSPELL  ,                   -1,/*  0541 */
TE_SPADD   ,                   -1,/*  0542  $    */
TE_SPREM   ,                   -1,/*  0543     */

TE_HELP    ,PF3 ,'/',          -1,/*  0544  help */
TE_HELP    ,PF3 ,'?',          -1,/*  0544  help */
TE_HELP    ,Help,              -1,/*  0544  help */
TE_OHELP   ,PF3 ,'H',          -1,/*  0544  help */
TE_OHELP   ,PF3 ,'h',          -1,/*  0544  help */
TE_MSGS    ,PF3 ,'!',          -1,/* 01013     */
TE_FENTR   ,PF3 ,DOWN,         -1,/*  0545      */
TE_F2ENTR  ,PF3 ,PF3 ,         -1,/*  0546         */
TE_FEXEC   ,PF3,Enter,         -1,/*  0547    */
TE_EXEC    ,PF2,Enter,         -1,/*  0547    */
TE_SHELL   ,Enter,             -1,/*  0550      cli */
TE_INFILE  ,PF3,RIGHT,         -1,/*  0551  enter filename */
TE_OUTFILE ,PF3,LEFT,          -1,/*  0552  leave filename */

TE_MODFILE ,PF3,CTRL_U,        -1,

TE_UPDATE  ,PF2,PF3,           -1,/*  0553      */
TE_EXIT    ,PF3,UP,            -1,/*  0554       */
TE_EXOLD   ,PF3,CTRL_C,        -1,/*  0555       */
TE_EXBACK  ,PF3,ZB,            -1,/*  0556         */
TE_QUIT    ,PF1,PF1,           -1,/*  0557      */
TE_CRASH   ,CTRL_Y,            -1,/*  0557      */
TE_NERROR  ,F10, DOWN,         -1,/*  0560      */
TE_PERROR  ,F10, UP,           -1,/*  0561     */
TE_ERROFF  ,F10, F10,          -1,/* 01022     */
TE_STATUS  ,F7,                -1,/* 01023     */
TE_FORK    ,PF3,PF4,           -1,/*  0562   fork     */
TE_FORK    ,F11,               -1,/*  0562   fork     */
TE_FOCUS   ,TE_FOCUS,          -1,/*  0562   fork     */
TE_SETXY   ,TE_SETXY,          -1,/*  0562   fork     */

TK_BREAK   ,CTRL_C,            -1,/*  0570       */
TK_CTRLO   ,CTRL_Z,            -1,/*  0571  /    */
TK_REPEAT  ,PF2 ,PF2 ,         -1,/*  0573  /   */
TK_BRUS    ,                   -1,/*  0574  /   */
TK_SRUS    ,CTRL_O,            -1,/*  0575  a    */
TK_BLAT    ,                   -1,/*  0576  /   */
TK_SLAT    ,CTRL_N,            -1,/*  0577  a    */
TK_SM+0    ,PF2 ,N4,           -1,/*  0600     0 */
TK_EM+0    ,N4,                -1,/*  0700   /  0 */
TK_SM+1    ,PF2,PF1,'1',       -1,/*  0600     0 */
TK_EM+1    ,    PF1,'1',       -1,/*  0700   /  0 */
TK_SM+2    ,PF2,PF1,'2',       -1,/*  0600     0 */
TK_EM+2    ,    PF1,'2',       -1,/*  0700   /  0 */
TK_SM+3    ,PF2,PF1,'3',       -1,/*  0600     0 */
TK_EM+3    ,    PF1,'3',       -1,/*  0700   /  0 */
TK_SM+4    ,PF2,PF1,'4',       -1,/*  0600     0 */
TK_EM+4    ,    PF1,'4',       -1,/*  0700   /  0 */
TK_SM+5    ,PF2,PF1,'5',       -1,/*  0600     0 */
TK_EM+5    ,    PF1,'5',       -1,/*  0700   /  0 */
TK_SM+6    ,PF2,PF1,'6',       -1,/*  0600     0 */
TK_EM+6    ,    PF1,'6',       -1,/*  0700   /  0 */
TK_SM+7    ,PF2,PF1,'7',       -1,/*  0600     0 */
TK_EM+7    ,    PF1,'7',       -1,/*  0700   /  0 */
TK_SM+8    ,PF2,PF1,'8',       -1,/*  0600     0 */
TK_EM+8    ,    PF1,'8',       -1,/*  0700   /  0 */
TK_SM+9    ,PF2,PF1,'9',       -1,/*  0600     0 */
TK_EM+9    ,    PF1,'9',       -1,/*  0700   /  0 */
TK_SM+10   ,PF2,PF1,'0',       -1,/*  0600     0 */
TK_EM+10   ,    PF1,'0',       -1,/*  0700   /  0 */
TK_SM+11   ,                   -1,/*  0600     0 */
TK_EM+11   ,                   -1,/*  0700   /  0 */

TD_SDEQ    ,PF1,'D',           -1,/*  01001* /  */
TD_SDEQ    ,PF1,'d',           -1,/*  01001* /  */
TD_STXT    ,                   -1,/*  01002* /  */
TK_CSET    ,PF1,N2,            -1,
TK_CADD    ,PF1,N9,            -1,
TK_CSUB    ,PF1,N8,            -1,
TK_CPUT    ,PF1,N3,            -1,
TK_DATE    ,PF1,CTRL_D,        -1,/*  01005  "   */
TK_TIME    ,PF1,CTRL_T,        -1,/*  01006  "   */
MC_SAVE    ,COMMA,COMMA,N0,    -1,/*  01007  "    */
MC_LOAD    ,COMMA,COMMA,DOT,   -1,/*  01010  '    */
MC_2SAVE   ,COMMA,N0,          -1,/*  01011  "    */
MC_2LOAD   ,COMMA,DOT,         -1,/*  01012  '    */

EX_EXEC    ,N1,                -1,/*  02030  '    */
EX_CEXEC   ,PF2,N1,            -1,/*  02031  '    */
EX_FEXEC   ,PF3,N1,            -1,/*  02032  '    */

MC_INCL    ,PF3,'j',           -1,/*  02000  '    */
MC_INCL    ,PF3,'J',           -1,/*  02000  '    */
MC_PROC    ,PF3,'p',           -1,/*  02000  '    */
MC_PROC    ,PF3,'P',           -1,/*  02000  '    */
MC_SUBR    ,PF3,'s',           -1,/*  02000  '    */
MC_SUBR    ,PF3,'S',           -1,/*  02000  '    */
MC_FUNC    ,PF3,'f',           -1,/*  02000  '    */
MC_FUNC    ,PF3,'F',           -1,/*  02000  '    */
MC_WHIL    ,PF3,'w',           -1,/*  02000  '    */
MC_WHIL    ,PF3,'W',           -1,/*  02000  '    */
MC_DO      ,PF3,'d',           -1,/*  02000  '    */
MC_DO      ,PF3,'D',           -1,/*  02000  '    */
MC_IF      ,PF3,'i',           -1,/*  02000  '    */
MC_IF      ,PF3,'I',           -1,/*  02000  '    */

DB_DUMP    ,PF3,'V',           -1,/*  02000  '    */
DB_DUMP    ,PF3,'v',           -1,/*  02000  '    */
DB_TRACE   ,PF3,'T',           -1,/*  02000  '    */
DB_TRACE   ,PF3,'t',           -1,/*  02000  '    */

-1};

short special_table[] = {

TK_ESC     ,ESC,               /*  0572  Esc */
TK_ESC     ,PF3,               /*  0572  Esc */
-1};

#include "gentab.c"
