/*       The folowing have to define:
 *
 *   MAXTABS        - number of tables,
 *   MAXLENTAB      - number of elements in a table,
 *   FILE_NAME      - file name for tables saving,
 *                  - tables are saved in  ${MIMTERMINFO} directory
 *   short origin_table[] = { ... } - describing elements
 *   short special_table[] = { ... } - describing special elements
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/*      */
#define DEFAULT_MIMTERMINFO     "/usr/local/lib/mim"

#ifndef VMS
#define PREFSTR "%s/%s"
#else
#define PREFSTR "%s%s"
#endif

int main ()
{
  short len_tab[MAXTABS];
  struct tab_elem
  {
    short token;
    short code;
  };
  struct tab_elem table[MAXTABS][MAXLENTAB];
  struct tab_elem *tp, el;
  short tab_count, elem_count, i, j, k, l, n, token;
  int fd;
  char *nm_lib, fn[256];

  nm_lib = getenv ("MIMTERMINFO");
  if (nm_lib == NULL)
    {
      printf ("MIMTERMINFO missing in environ. Using default %s\n",
              DEFAULT_MIMTERMINFO);
      nm_lib = DEFAULT_MIMTERMINFO;
    }
  printf("nm_lib=%s\n", nm_lib);
  i = 0;
  tab_count = 1;
  elem_count = 0;
  len_tab[0] = 0;
  while (origin_table[i] >= 0)
    {
      token = origin_table[i++];
      if (origin_table[i] < 0)
        i++;
      else
        {
          j = 0;
          while (1)
            {
              for (k = 0; k < len_tab[j]; k++)
                {
                  if (table[j][k].token == origin_table[i])
                    break;
                }
              if (k < len_tab[j])
                {               /*
                                 */
                  if ((origin_table[i + 1] >= 0) && (table[j][k].code < 0))
                    {
                      j = -table[j][k].code;
                    }
                  else
                    {
                      printf ("Error in definition 0%o\n", token);
                      for (; origin_table[i] >= 0; i++);
                      i++;
                      break;
                    }
                }
              else
                {
                  if (len_tab[j] >= MAXLENTAB)
                    {
                      printf ("Too long table !");
                      return (1);
                    }
                  tp = (struct tab_elem *) &(table[j][len_tab[j]++]);
                  tp->token = origin_table[i];
                  elem_count++;
                  if (origin_table[i + 1] >= 0)
                    {
                      if (tab_count >= MAXTABS)
                        {
                          printf ("Too many tables !");
                          return (1);
                        }
                      tp->code = -tab_count;
                      j = tab_count++;
                      len_tab[j] = 0;
                    }
                  else
                    {
                      tp->code = token;
                      break;
                    }
                }
              i++;
            }
        }
    }


  for (n = 0; n < tab_count; n++)
    {
      k = (l = len_tab[n] - 1);
      while (k <= l)
        {
          l = -1;
          j = k;
          for (i = 1; i <= j; i++)
            {
              l = i - 1;
              if (table[n][l].token > table[n][i].token)
                {
                  el = table[n][l];
                  table[n][l] = table[n][i];
                  table[n][i] = el;
                  k = l;
                }
            }
        }
    }


#define twrite(w)  write(fd, (char *) &(w), sizeof(w))

  sprintf (fn, PREFSTR, nm_lib, FILE_NAME);
  fd = creat (fn, 0666);
  if (fd == -1)
    {
      printf ("Error in \'creat\' for  '%s'\n", fn);
      return 1;
    }
  twrite (tab_count);
  printf ("tab_count = %d\n", tab_count);
  twrite (elem_count);
  printf ("elem_count = %d\n", elem_count);
  for (i = 0; i < tab_count; i++)
    {
      twrite (len_tab[i]);
      /* printf("len_tab[%d] = %d\n",i,len_tab[i]); */
      for (j = 0; j < len_tab[i]; j++)
        {
          twrite (table[i][j]);
          /* printf("   table[%d][%d] = {0%o,%d}\n",i,j,
             table[i][j].token,table[i][j].code);     */
        }
    }
  elem_count = 0;
  for (i = 0; special_table[2 * i] >= 0; i++)
    {
      table[0][i].token = special_table[2 * i + 1];
      table[0][i].code = special_table[2 * i];
      elem_count++;
    }
  twrite (elem_count);
  printf ("special_count = %d\n", elem_count);
  for (i = 0; i < elem_count; i++)
    {
      twrite (table[0][i]);
      /* printf("   table[%d] = {0%o,0%o}\n",i,
         table[0][i].token,table[0][i].code); */
    }

  close (fd);
}
