#include "kbxlinux-vvb.h"
#include "cmn.h"
#include "xi_keys.h"

#define MAXTABS 50
#define MAXLENTAB 200
#define FILE_NAME "xlinux-vvb.kb"

short origin_table[] = {

CTRL_A          , 0001,                  -1,
CTRL_B          , 0002,                  -1,
CTRL_C          , 0003,                  -1,
CTRL_D          , 0004,                  -1,
CTRL_E          , 0005,                  -1,
/* CTRL_F       , 0006,                  -1, */
Home            , 0006,                  -1,
CTRL_G          , 0007,                  -1,
CTRL_H          , 0010,                  -1,
CTRL_I          , 0011,                  -1,
CTRL_J          , 0012,                  -1,
CTRL_K          , 0013,                  -1,
CTRL_L          , 0014,                  -1,
CTRL_M          , 0015,                  -1,
CTRL_N          , 0016,                  -1,
CTRL_O          , 0017,                  -1,
CTRL_P          , 0020,                  -1,
CTRL_Q          , 0021,                  -1,
CTRL_R          , 0022,                  -1,
CTRL_S          , 0023,                  -1,
CTRL_T          , 0024,                  -1,
CTRL_U          , 0025,                  -1,
CTRL_V          , 0026,                  -1,
CTRL_W          , 0027,                  -1,
CTRL_X          , 0030,                  -1,
CTRL_Y          , 0031,                  -1,
CTRL_Z          , 0032,                  -1,

N8              , 0377,                  -1,
ZB              , 01010,                 -1,
CTRL_BackSpace  , 0237,                  -1,
CTRL_BackSpace  , 03010,                 -1,

ESC             , 01033,                 -1,
ESC             , 011033,                -1,

Tab             , 01011,                 -1,
SHIFT_Tab       , 01411,                 -1,
CTRL_Tab        , 03011,                 -1,
Return          , 01015,                 -1,
Return          , 011015,                -1,
CTRL_Return     , 03015,                 -1,
SHIFT_Return    , 01415,                 -1,

TE_FORK         , F12,                   -1,

N0              , 01260,                 -1,
N0              , 01236,                 -1,
N1              , 01261,                 -1,
N1              , 01234,                 -1,
N2              , 01262,                 -1,
N2              , 01231,                 -1,
N3              , 01263,                 -1,
N3              , 01233,                 -1,
N4              , 01264,                 -1,
N4              , 01226,                 -1,
N5              , 01265,                 -1,
N5              , 01235,                 -1,
N6              , 01266,                 -1,
N6              , 01230,                 -1,
N7              , 01267,                 -1,
N7              , 01225,                 -1,
N8              , 01270,                 -1,
N8              , 01227,                 -1,
Insert          , 01271,                 -1,
Insert          , 01232,                 -1,
Insert          , 01143,                 -1,
Insert          , 011143,                -1,
Insert          , 01243,                 -1,
CTRL_Insert     , 03143,                 -1,
SHIFT_Insert    , 01543,                 -1,
DOT             , 01256,                 -1,
DOT             , 01237,                 -1,
Enter           , 01215,                 -1,
Enter           , 011215,                -1,
PLUS            , 01253,                 -1,
UP              , 01122,                 -1,
SHIFT_UP        , 01522,                 -1,
DOWN            , 01124,                 -1,
DOWN            , 011124,                -1,
SHIFT_DOWN      , 01524,                 -1,
SHIFT_DOWN      , 011524,                -1,
RIGHT           , 01123,                 -1,
RIGHT           , 011123,                -1,
SHIFT_RIGHT     , 01523,                 -1,
SHIFT_RIGHT     , 011523,                -1,
LEFT            , 01121,                 -1,
LEFT            , 011121,                -1,
SHIFT_LEFT      , 01521,                 -1,
SHIFT_LEFT      , 011521,                -1,
Home            , 01222,                 -1,
Home            , 011222,                -1,
Home            , 01257,                 -1,
Home            , 011257,                -1,
ESC             , 01223,                 -1,
ESC             , 011223,                -1,
ESC             , 01252,                 -1,
ESC             , 011252,                -1,
PF4             , 01224,                 -1,
PF4             , 011224,                -1,
PF4             , 01255,                 -1,
PF4             , 011255,                -1,
F1              , 01276,                 -1,
CTRL_F1         , 03276,                 -1,
SHIFT_F1        , 01676,                 -1,
SHIFT_F1        , 01710,                 -1,
F2              , 01277,                 -1,
CTRL_F2         , 03277,                 -1,
SHIFT_F2        , 01677,                 -1,
SHIFT_F2        , 01711,                 -1,
F3              , 01300,                 -1,
CTRL_F3         , 03300,                 -1,
SHIFT_F3        , 01700,                 -1,
SHIFT_F3        , 01712,                 -1,
F4              , 01301,                 -1,
CTRL_F4         , 03301,                 -1,
SHIFT_F4        , 01701,                 -1,
SHIFT_F4        , 01713,                 -1,
F5              , 01302,                 -1,
CTRL_F5         , 03302,                 -1,
SHIFT_F5        , 01702,                 -1,
SHIFT_F5        , 01714,                 -1,
F6              , 01303,                 -1,
CTRL_F6         , 03303,                 -1,
SHIFT_F6        , 01703,                 -1,
SHIFT_F6        , 01715,                 -1,
F7              , 01304,                 -1,
F7              , 011304,                -1,
CTRL_F7         , 03304,                 -1,
SHIFT_F7        , 01704,                 -1,
SHIFT_F7        , 01716,                 -1,
F8              , 01305,                 -1,
CTRL_F8         , 03305,                 -1,
SHIFT_F8        , 01705,                 -1,
SHIFT_F8        , 01717,                 -1,
F9              , 01306,                 -1,
CTRL_F9         , 03306,                 -1,
SHIFT_F9        , 01706,                 -1,
SHIFT_F9        , 01720,                 -1,
F10             , 01307,                 -1,
CTRL_F10        , 03307,                 -1,
SHIFT_F10       , 01707,                 -1,
SHIFT_F10       , 01721,                 -1,
SHIFT_F10       , 011721,                -1,
F11             , 01310,                 -1,
CTRL_F11        , 03310,                 -1,
F12             , 01311,                 -1,
CTRL_F12        , 03311,                 -1,
Home            , 01120,                 -1,
Home            , 011120,                -1,
SHIFT_Home      , 01520,                 -1,
SHIFT_Home      , 011520,                -1,
End             , 01127,                 -1,
End             , 011127,                -1,
SHIFT_End       , 01527,                 -1,
SHIFT_End       , 011527,                -1,
PageUp          , 01125,                 -1,
PageUp          , 011125,                -1,
SHIFT_PageUp    , 01525,                 -1,
SHIFT_PageUp    , 011525,                -1,
PageDown        , 01126,                 -1,
PageDown        , 011126,                -1,
SHIFT_PageDown  , 01526,                 -1,
SHIFT_PageDown  , 011526,                -1,

CTRL_LEFT       , 03121,                 -1,
CTRL_UP         , 03122,                 -1,
CTRL_RIGHT      , 03123,                 -1,
CTRL_DOWN       , 03124,                 -1,

Help            , 01152,                 -1,
Help            , 01552,                 -1,
Do              , 01147,                 -1,
ShiftDo         , 01547,                 -1,

Find            , 01150,                 -1,
ShiftFind       , 01550,                 -1,

Select          , 01140,                 -1,
ShiftSelect     , 01540,                 -1,

SHIFT_DELETE    , XI_KEY_SHIFT_DELETE,      -1,    /* Delete line: Shift+Delete */

TE_FOCUS   ,TE_FOCUS,          -1,
TE_SETXY   ,TE_SETXY,          -1,

LE_TAB     ,LE_TAB,            -1,
TE_CR      ,TE_CR,             -1,
-1};

short special_table[] = {
ESC             , 033,
-1};

#include "../gentab.c"

