#include "kbxlinux.h"
#include "cmn.h"
#include "xi_keys.h"

#define MAXTABS 200
#define MAXLENTAB 800
/*
#define MAXTABS 50
#define MAXLENTAB 200
*/
#define FILE_NAME "xlinux.kb"

short origin_table[] = {

CTRL_A          , 00001                 , -1,
CTRL_B          , 00002                 , -1,
CTRL_C          , 00003                 , -1,
CTRL_D          , 00004                 , -1,
CTRL_E          , 00005                 , -1,
CTRL_F          , 00006                 , -1,
CTRL_G          , 00007                 , -1,
CTRL_H          , 00010                 , -1,
CTRL_I          , 00011                 , -1,
TAB             , 01011                 , -1,
CTRL_J          , 00012                 , -1,
CTRL_K          , 00013                 , -1,
CTRL_L          , 00014                 , -1,
CTRL_M          , 00015                 , -1,
RETURN          , 01015                 , -1,
RETURN          , 01215                 , -1, /* ENTER */
CTRL_N          , 00016                 , -1,
CTRL_O          , 00017                 , -1,
CTRL_P          , 00020                 , -1,
CTRL_Q          , 00021                 , -1,
CTRL_R          , 00022                 , -1,
CTRL_S          , 00023                 , -1,
CTRL_T          , 00024                 , -1,
CTRL_U          , 00025                 , -1,
CTRL_V          , 00026                 , -1,
CTRL_W          , 00027                 , -1,
CTRL_X          , 00030                 , -1,
CTRL_Y          , 00031                 , -1,
CTRL_Z          , 00032                 , -1,
BACKSPACE       , 01010                 , -1,

UP              , 01122                 , -1,
DOWN            , 01124                 , -1,
RIGHT           , 01123                 , -1,
LEFT            , 01121                 , -1,
F1              , 01276                 , -1,
F2              , 01277                 , -1,
F3              , 01300                 , -1,
F4              , 01301                 , -1,
F5              , 01302                 , -1,
F6              , 01303                 , -1,
F7              , 01304                 , -1,
F8              , 01305                 , -1,
F9              , 01306                 , -1,
F10             , 01307                 , -1,

SHIFT_F1        , 01676                 , -1,
SHIFT_F2        , 01677                 , -1,
SHIFT_F3        , 01700                 , -1,
SHIFT_F4        , 01701                 , -1,
SHIFT_F5        , 01702                 , -1,
SHIFT_F6        , 01703                 , -1,
SHIFT_F7        , 01704                 , -1,
SHIFT_F8        , 01705                 , -1,
SHIFT_F9        , 01706                 , -1,
SHIFT_F10       , 01707                 , -1,

CTRL_F1         , 03276                 , -1,
CTRL_F2         , 03277                 , -1,
CTRL_F3         , 03300                 , -1,
CTRL_F4         , 03301                 , -1,
CTRL_F5         , 03302                 , -1,
CTRL_F6         , 03303                 , -1,
CTRL_F7         , 03304                 , -1,
CTRL_F8         , 03305                 , -1,
CTRL_F9         , 03306                 , -1,
CTRL_F10        , 03307                 , -1,

CTRL_SHIFT_F1   , 03676                 , -1,
CTRL_SHIFT_F2   , 03677                 , -1,
CTRL_SHIFT_F3   , 03700                 , -1,
CTRL_SHIFT_F4   , 03701                 , -1,
CTRL_SHIFT_F5   , 03702                 , -1,
CTRL_SHIFT_F6   , 03703                 , -1,
CTRL_SHIFT_F7   , 03704                 , -1,
CTRL_SHIFT_F8   , 03705                 , -1,
CTRL_SHIFT_F9   , 03706                 , -1,
CTRL_SHIFT_F10  , 03707                 , -1,

F11             , 01310                 , -1,
F12             , 01311                 , -1,
SHIFT_F11       , 01710                 , -1,
SHIFT_F12       , 01711                 , -1,
CTRL_F11        , 03310                 , -1,
CTRL_F12        , 03311                 , -1,
CTRL_SHIFT_F11  , 03710                 , -1,
CTRL_SHIFT_F12  , 03711                 , -1,
SHIFT_PLUS      , 01653                 , -1,
ALT_ESC         , 05033                 , -1,

SHIFT_LEFT      , 01521                 , -1,
SHIFT_LEFT      , 01664                 , -1, /* SHIFT_N4 */
CTRL_LEFT       , 03121                 , -1,
CTRL_LEFT       , 03226                 , -1, /* CTRL_N4 */
ALT_LEFT        , 05121                 , -1,
ALT_LEFT        , 05226                 , -1, /* ALT_N4 */
CTRL_SHIFT_LEFT , 03521                 , -1,
CTRL_SHIFT_LEFT , 03664                 , -1, /* CTRL_SHIFT_N4 */

SHIFT_RIGHT     , 01523                 , -1,
SHIFT_RIGHT     , 01666                 , -1, /* SHIFT_N6 */
CTRL_RIGHT      , 03123                 , -1,
CTRL_RIGHT      , 03230                 , -1, /* CTRL_N6 */
ALT_RIGHT       , 05123                 , -1,
ALT_RIGHT       , 05230                 , -1, /* ALT_N6 */
CTRL_SHIFT_RIGHT, 03523                 , -1,
CTRL_SHIFT_RIGHT, 03666                 , -1, /* CTRL_SHIFT_N6 */

ALT_UP          , 05122                 , -1,
ALT_UP          , 05227                 , -1, /* ALT_N8 */
SHIFT_UP        , 01522                 , -1,
SHIFT_UP        , 01670                 , -1, /* SHIFT_N8 */
CTRL_UP         , 03122                 , -1,
CTRL_UP         , 03227                 , -1, /* CTRL_N8 */
CTRL_SHIFT_UP   , 03522                 , -1,
CTRL_SHIFT_UP   , 03670                 , -1, /* CTRL_SHIFT_N8 */

ALT_DOWN        , 05124                 , -1,
ALT_DOWN        , 05231                 , -1, /* ALT_N2 */
SHIFT_DOWN      , 01524                 , -1,
SHIFT_DOWN      , 01662                 , -1, /* SHIFT_N2 */
CTRL_DOWN       , 03124                 , -1,
CTRL_DOWN       , 03231                 , -1, /* CTRL_N2 */
CTRL_SHIFT_DOWN , 03524                 , -1,
CTRL_SHIFT_DOWN , 03662                 , -1, /* CTRL_SHIFT_N2 */

SHIFT_INSERT    , 01543                 , -1,
SHIFT_INSERT    , 01660                 , -1, /* SHIFT_N0 */
CTRL_INSERT     , 03143                 , -1,
CTRL_INSERT     , 03236                 , -1, /* CTRL_N0 */
SHIFT_DELETE    , XI_KEY_SHIFT_DELETE   , -1,
SHIFT_DELETE    , 01656                 , -1, /* SHIFT_DOT */
CTRL_DELETE     , 00237                 , -1,
CTRL_DELETE     , 03237                 , -1, /* CTRL_DOT */
SHIFT_TAB       , XI_KEY_SHIFT_TAB      , -1,
CTRL_TAB        , 03011                 , -1,
CTRL_SHIFT_TAB  , XI_KEY_CTRL_SHIFT_TAB , -1,
SHIFT_BACKSPACE , 01410                 , -1,
CTRL_BACKSPACE  , 03010                 , -1,
CTRL_SHIFT_SPACE, XI_KEY_CTRL_SHIFT_SPACE, -1,

CTRL_ENTER      , 03215                 , -1,
CTRL_RETURN     , 03015                 , -1,
SHIFT_RETURN    , 01415                 , -1,
CTRL_SHIFT_RETURN,03415                 , -1,
ALT_SHIFT_RETURN, 05415                 , -1,
CTRL_PageUp     , 03125                 , -1,
CTRL_PageUp     , 03232                 , -1, /* CTRL_N9 */
CTRL_PageDown   , 03126                 , -1,
CTRL_PageDown   , 03233                 , -1, /* CTRL_N3 */
SHIFT_STAR      , 01652                 , -1,
ALT_STAR        , 05252                 , -1,
ALT_CTRL_STAR   , 07252                 , -1,
ALT_MINUS       , 05255                 , -1,
SHIFT_MINUS     , 01655                 , -1,

CTRL_1          , 00321                 , -1,
CTRL_2          , 00322                 , -1,
CTRL_3          , 00323                 , -1,
CTRL_4          , 00324                 , -1,
CTRL_5          , 00325                 , -1,
CTRL_6          , 00326                 , -1,
CTRL_7          , 00327                 , -1,
CTRL_8          , 00330                 , -1,
CTRL_9          , 00331                 , -1,
CTRL_0          , 00320                 , -1,

#if 1
CTRL_QUESTION   , XI_KEY_CTRL_QUESTION  , -1,
#else
/* Why this does not work? */
CTRL_QUESTION   , 00317                 , -1,
#endif
CTRL_SPACE      , XI_KEY_CTRL_SPACE     , -1,

CTRL_SHIFT_1    , 00301                 , -1,
CTRL_SHIFT_2    , XI_KEY_CTRL_SHIFT_2   , -1,
CTRL_SHIFT_3    , 00303                 , -1,
CTRL_SHIFT_4    , 00304                 , -1,
CTRL_SHIFT_5    , 00305                 , -1,
CTRL_SHIFT_6    , XI_KEY_CTRL_SHIFT_6   , -1,
CTRL_SHIFT_7    , 00306                 , -1,
CTRL_SHIFT_8    , 00312                 , -1,
CTRL_SHIFT_9    , 00310                 , -1,
CTRL_SHIFT_0    , 00311                 , -1,

HOME            , 01120                 , -1,
INSERT          , 01143                 , -1,
DELETE          , 00377                 , -1,
END             , 01127                 , -1,
PageUp          , 01125                 , -1,
PageDown        , 01126                 , -1,
SLASH           , 01257                 , -1,
STAR            , 01252                 , -1,
MINUS           , 01255                 , -1,
/* ENTER           , 01215                 , -1, */
DOT             , 01237                 , -1,
N0              , 01236                 , -1,
N1              , 01234                 , -1,
N2              , 01231                 , -1,
N3              , 01233                 , -1,
N4              , 01226                 , -1,
N5              , 01235                 , -1,
N6              , 01230                 , -1,
N7              , 01225                 , -1,
N8              , 01227                 , -1,
N9              , 01232                 , -1,
PLUS            , 01253                 , -1,
Pause           , 01023                 , -1,
WIN_1_UP        ,041122                 , -1,
WIN_1_DOWN      ,041124                 , -1,
WIN_1_RIGHT     ,041123                 , -1,
WIN_1_LEFT      ,041121                 , -1,
WIN_2           , 01040                 , -1,
WIN_3           , 01147                 , -1,
SHIFT_WIN_2     , 01440                 , -1,
SHIFT_WIN_3     , 01547                 , -1,
ALT_WIN_2       , 05040                 , -1,
ALT_WIN_3       , 05147                 , -1,

ALT_CTRL_UP	, 07122 		, -1,
ALT_CTRL_UP	, 07227 		, -1,	/* ALT_CTRL_N8 */
ALT_CTRL_DOWN	, 07124 		, -1,
ALT_CTRL_DOWN	, 07231 		, -1,	/* ALT_CTRL_N2 */

ALT_CTRL_SHIFT_LEFT , 07521		, -1,
ALT_CTRL_SHIFT_LEFT , 07664		, -1,	/* ALT_CTRL_SHIFT_N4 */
ALT_CTRL_SHIFT_UP   , 07522		, -1,
ALT_CTRL_SHIFT_UP   , 07670		, -1,	/* ALT_CTRL_SHIFT_N8 */
ALT_CTRL_SHIFT_RIGHT, 07523		, -1,
ALT_CTRL_SHIFT_RIGHT, 07666		, -1,	/* ALT_CTRL_SHIFT_N6 */
ALT_CTRL_SHIFT_DOWN , 07524		, -1,
ALT_CTRL_SHIFT_DOWN , 07662		, -1,	/* ALT_CTRL_SHIFT_N2 */

KEY_FOCUS       , XI_KEY_FOCUS          , -1,
KEY_SETXY       , XI_KEY_SETXY          , -1,

LE_TAB          , LE_TAB                , -1,
TE_CR           , TE_CR                 , -1,

ESC             , 01033                 , -1,
-1 };

short special_table[] = {
ESC             , 033,
-1};

#include "gentab.c"
