/*
 *     nanoMir
 *
 *     "nm.h"           Main include 
 */

/* Applications */
/* Don't define following defs here. They must be define in makefile. */
/* #define NM  *//* nanoMir editor */
/* #define C93 *//* Antilope-GNU C */
/* #define X11 *//* nanoMir for X Version 11 */

#undef DEBUG
#define HACK			/* include Maly's experiments */
#define ERRVIEW			/* include compiler's error viewer */
#define DBFLUSH 0
#define DBFS    0

/* Platforms */
/* Don't define following defs here. They must be define in makefile. */
/* #define BESTA *//* Besta -- Russian workstantion: mc680x0, SVR3.1 */
/* #define UNIX  */
/* #define VAX   */
/* #define VMS   */
/* #define ix86  */

/* Language of messages */
/* Don't define following defs here. They must be define in makefile. */
/* #define RUSSIAN */
/* #define ENGLISH */

#ifdef VMS
#define LONG_FILE_NAME
#endif
#ifdef MIM_SVR4
#define LONG_FILE_NAME
#endif

#ifdef VMS
#include <types.h>
#else
#include <sys/types.h>
#endif
#ifndef AIX
/* AIX defines uchar in <sys/types.h> */
typedef unsigned char uchar;
#endif /* AIX */
#define bool short

#ifdef BESTA
#define NIL   0L

typedef short small;
typedef unsigned short uword;
typedef long large;
typedef long addr;
typedef long tchar;

#define cpdiff( p1, p2 ) ((p1)-(p2))
#define ctotc(c) ((unsigned char)(c))

#endif /* def BESTA */

#ifdef VAX
#define NIL   0L

typedef short small;
typedef unsigned short uword;
#ifdef VMS
typedef unsigned short ushort;
#endif
typedef long large;
typedef long addr;
typedef ushort tchar;

#define cpdiff( p1, p2 ) ((p1)-(p2))
#define ctotc(c) ((uchar)(c))

#endif /* def VAX */

#ifdef ALPHA			/* Computer ALPHA AXP                */
#define NIL   0L

typedef short small;
typedef unsigned short uword;
typedef int large;
typedef long addr;
typedef unsigned short tchar;
#define cpdiff( p1, p2 ) ((p1)-(p2))
#define ctotc(c) ((unsigned char)(c))

#endif /* def ALPHA */

#ifdef ix86			/* Intel >= 80386            */
#define NIL   0L

typedef short int small;	/* 16 bit signed integer     */
typedef unsigned short uword;	/* 16 bit unsigned integer   */
typedef long large;		/* 32 bit integer            */
typedef long addr;
typedef long tchar;

#define cpdiff( p1, p2 ) ((p1)-(p2))
#define ctotc(c) ((unsigned char)(c))

#endif /* def ix86 */

#ifdef PowerPC                  /* PowerPC                   */
#define NIL   0L

typedef short int small;        /* 16 bit signed integer     */
typedef unsigned short uword;   /* 16 bit unsigned integer   */
typedef long large;             /* 32 bit integer            */
typedef long addr;
typedef long tchar;

#define cpdiff( p1, p2 ) ((p1)-(p2))
#define ctotc(c) ((unsigned char)(c))

#endif /* def PowerPC */

/*  ,       ,
       .     X11 . */
#ifdef X11
#define STATUS_IN_MAIN_WINDOW   1
#endif

#define local   static
#ifdef TRUE
#undef TRUE
#endif
#ifdef FALSE
#undef FALSE
#endif
#define TRUE    ((bool)1)
#define FALSE   ((bool)0)
#define MAXLARGE 2000000000L

#define MAXFILES 100
#define MAXDEQS  (MAXFILES*3+5)

#define MAXUSRLN 40
#define MAXGRPLN 40

#ifdef LONG_FILE_NAME
#define MAXFILELN  255
#define MAXFILELN1 22
#else
#define MAXFILELN 14
#define MAXFILELN1 MAXFILELN
#endif
#define FULL_FILE_NAME_POSITION 152

#ifdef UNIX
#define MASK "rwxrwxrwx"
/* #define MASK "rw-r--r--" */
#endif
#ifdef VMS
#define MASK "rwerwerwe"
#endif

#ifndef X11
#define NMTERM "MIMTERM"
#else
#define NMTERM "XMIMTERM"
#endif
#define NMTERMINFO "MIMTERMINFO"

#define MAXWNDWS 20
#define MAXPATH  256
#define MACSIZMAX 1024
#define MACNOMAX  12

#define MEMEXT   8192
#define MEMFREEMIN 0x0020000L
#define STKEXT   4096
#define UNDOEXT  4096
#define MAXLPAC  256
#define MAXFWORD 256
#define MAXLUP   512
#define UBUFSIZ  2048
#define UDHQUOTA 16384
#define UDLQUOTA 8192
#define MAXDIRSTK 10

extern char clibpath[];
extern char nmlocal[];

#define ERRFILE   "errors.out"
#define MSGFILE   "file.msg"

#ifdef VMS
# define ROOTFILE  "MICROS.MIM"
# define DIREXT    ".MIM"
#endif /* def VMS */
#ifdef UNIX
# define ROOTFILE  "micros.dir"
# define DIREXT    ".dir"
#endif /* def UNIX */
#define DBSIZE 12
#define MCD_LEFT  46
#define MCD_RIGHT 50

#define max( a, b ) ( (a)>(b) ? (a) : (b) )
#define min( a, b ) ( (a)<(b) ? (a) : (b) )
#define ABS( a )    ( (a)>=0 ? (a) : -(a) )

extern void otkaz ();

#ifdef DEBUG
#define assert( expr, mess ) if( !(expr) )otkaz( mess )
#else
#define assert( expr, mess )
#endif

#define TAB '\011'
#define LF  '\012'
#define FF  '\014'
#define CR  '\015'
#define NM_EOF '\032'
#define ESC '\033'

#define HYPHEN '-'

typedef struct
{				/*                             */
  char dsname[MAXPATH];		/*                        */
  small dswx;			/*                                             */
  small dsx;			/*                                             */
  large dswy;			/*                                             */
  large dsy;			/*                                             */
}
dirstk;

typedef struct
{
  void (*cfunc) ();
  small cattr;
}
comdesc;

#define deq     struct dq
struct dq
{
  char *dbeg;
  small dbext;
  char *dend;
  small deext;
  deq *dnext;
  deq *dprev;
  small dtyp;
  addr dextra;
/*deq *dtwin; */
  char *dbmem;
  char *demem;
};

typedef struct
{
  char finame[MAXPATH];
  small fiddl;
  small finml;
  small fiext;
  small fiattr;
  time_t fitime;
  uword fidate;
  large fisize;

  /*    */
  large flines;

  deq *txustk;
  deq *txdstk;
  large txy;
  deq *txudeq;
  large txudcptr;
  large txudlptr;

  small txredit;
#define TXED_YES     0
#define TXED_NO      1
#define TXED_NONO    2

  small txrm;
  small txmarkx;
  large txmarky;

  void *txwndptr;
  small txlructr;
  small txstat;
#define TS_BUSY    001
#define TS_FILE    002
#define TS_UNDO    004
#define TS_CHANGE  010
#define TS_PERM    020
#define TS_WND     040
#define TS_ERR    0100
#define TS_PERM1  0200
#define TS_NEW    0400
#define TS_DIRLST 01000
#define TS_DIRFIL 02000

  small cx;
  large cy;

  small tcx;
  large tcy;

}
txt;

#ifdef X11
#include <X11/Xlib.h>
#include <X11/Xutil.h>
typedef struct
{
  Window sbmain;
  Window sbslider;
  Window sbarrowup;
  Window sbarrowdown;
}
Scrollbar;
#endif

typedef struct
{
  small x0, x1;
  large y0, y1;
}
box;

#define wnd struct wndws
struct wndws
{
  large wty;
  small wtx;
  small wsy;
  small wsx;
  small wsh;
  small wsw;
  txt *wtext;
  tchar *(*winf) (wnd *, small, small *);
  wnd *wnext;
  small wstat;
#define WS_BUSY    001
#define WS_SHADOW  002
#define WS_DEBUG   004
#define WS_EMPTY   010
#define WS_ERROR   020
#define WS_NOTEXT  040

  dirstk stack[MAXDIRSTK];
  dirstk *dirsp;
  small wcx;
  large wcy;
  small wtyp;
#define  WND_NORMAL  0
#define  WND_SPECIAL 1
#define  WND_STATUS  3
#define  WND_ERROR   5
#ifdef X11
  Window wxwin;
  /*   */
  Window wxmain;
#ifdef STATUS_IN_MAIN_WINDOW
  /*   */
  Window wxstatusbar;
#endif				/* STATUS_IN_MAIN_WINDOW */
  Scrollbar wxsb;
  GC wxgc;
  GC wxigc;
  small wxcx;
  small wxcy;
  small wxstat;
#define WDX_REDRAW  001
#define WDX_CON     002
#define WDX_CACTIVE 004
  /*  0    */
  small block_active;
  /*  , 
        (b.x0,b.y0),    (b.x1,b.y1) */
  box block;
  /*      */
  int wnd_shown;
#endif
};

extern char *blkmov (char *from, char *to, small len);
extern void *GetMain (small amount);

extern char *sncpy (char *, char *, small), *scpy (char *, char *),
  *sindex (char *, char);

extern char stoupper (char);
extern char *ltox (char *, large), *xtol (char *, large *),
  *stod (char *, small);
extern bool scmp (char *, char *), sncmp (char *, char *, small);
extern small slen (char *);
extern char *dattoa (char *, small), *timtoa (char *, small);
extern char *dtol (char *, large *), *dtos (char *, small *);
extern void br14 (void);
extern char *swtoasc (), *asctosw ();
extern long atodate (char *);
extern char *attrtoa (char *, small);
extern time_t GetTime (void);
extern char *dttm (time_t t);

extern void exc (small);
#include <setjmp.h>
extern jmp_buf *excptr;

#ifdef KOI8
#define LDC_FIRST 0x83
#define LDC_LAST  0xaa
#else
#define LDC_FIRST 0200
#define LDC_LAST  0212
#endif /* KOI8 */

#ifdef C93
#define const
typedef unsigned char U_CHAR;
#endif

#define MICROS_DIR_FIELDS_SEPARATOR     0x89
/* #define MICROS_DIR_FIELDS_SEPARATOR     0x83 */
/* #define MICROS_DIR_FIELDS_SEPARATOR     0211 */

/*
 * The program starts rolling the screen when the cursor is ROLL_LINE
 * lines away from the screen edge. A value of 1 gives the usual behaviour
 * of text editors.
 */
#define ROLL_LINE 5

/*  ,    */
#define MIMFOREGROUND                   "MIMFOREGROUND"
/*  ,    */
#define MIMBACKGROUND                   "MIMBACKGROUND"

/*  ,    */
#define XMIMFOREGROUND                  "XMIMFOREGROUND"
/*  ,    */
#define XMIMBACKGROUND                  "XMIMBACKGROUND"
/*  ,   */
#define XMIMFONT                        "XMIMFONT"
/*  ,       */
#define XMIMSTFOREGROUND                "XMIMSTFOREGROUND"
/*  ,       */
#define XMIMSTBACKGROUND                "XMIMSTBACKGROUND"
/*  ,   */
#define MIMOPT                          "MIMOPT"
/*  ,   shell */
#define MIMSHELL                        "MIMSHELL"

/*    */
/*     */
#define DEFAULT_MIMLINESAVEFILE         "/tmp/linesave.mim"
/*     */
#define DEFAULT_MIMBLOCKSAVEFILE        "/tmp/blocksave.mim"
/*    */
#define DEFAULT_MIMTERMINFO             "/usr/local/lib/mim"
/*   */
#ifndef X11
#define DEFAULT_MIMTERM                 "linux"
#else
#define DEFAULT_MIMTERM                 "xlinux"
#endif

/*   */
/*  : 
 * "black" "red" "green" "yellow" "blue" "magenta" "cyan" "white"
 * "lightblack" "lightred" "lightgreen" "lightyellow" "lightblue" 
 * "lightmagenta" "lightcyan" "lightwhite"
 */
/*     */
#define DEFAULT_MIMFOREGROUND           "green"
/*     */
#define DEFAULT_MIMBACKGROUND           "black"

/* X11  */
/*   .  /usr/X11R6/lib/X11/rgb.txt */
/*     */
#define DEFAULT_XMIMFOREGROUND          "black"
/*     */
#define DEFAULT_XMIMBACKGROUND          "gray"
/*    */
#ifdef LINUX
/* For 1024x768 resolution */
/* #define DEFAULT_XMIMFONT		   "-cronyx-courier-medium-r-normal-*-*-140-*-*-m-*-koi8-r" */
/* For 800x600 resolution */
#define DEFAULT_XMIMFONT		"-cronyx-courier-medium-r-normal-*-*-120-*-*-m-*-koi8-r"
#else
#define DEFAULT_XMIMFONT                "fixed"
#endif
/*        */
#define DEFAULT_XMIMSTFOREGROUND        "white"
/*        */
#define DEFAULT_XMIMSTBACKGROUND        "DarkSlateBlue"

/*    ,   
      .    
     (, Ctrl-S, Ctrl-Q). */
/* #define USE_SYSTEM_KEYBORD_DRIVER       1 */
