/*
 *     nanoMir
 *
 *     "trm.c"          Terminfo emulation
 */

#include "nm.h"
#ifdef VMS
#include <stdarg.h>
#endif

int
tputs (char *s, int n, void (*putc) (char c))
{
  for (; *s; s++)
    (*putc) (*s);
  return 1;
}

local char tstack[128];
local char *tsp;
void
tstinit ()
{
  tsp = tstack;
}

char
tpop ()
{
  if (tsp <= tstack)
    return 0;
  return *--tsp;
}

void
tpush (char e)
{
  *tsp++ = e;
}

local char buf[512];
local char number[10];

#define	UNNAMED_ARG_TYPE	int

char *
tparm (char *s, ...)
{
  char *pb;
  int i;
  UNNAMED_ARG_TYPE args[10];

  {
    /* Calculate number of arguments. */
    char *p;
    int nargs = 0, k;

    for (p = s; *p; p++)
      {
	if (*p == '%' && *(p + 1) == 'p')
	  {
	    k = *(p + 2) - '0';
	    if (k > 0 && k < 10 && k > nargs)
	      nargs = k;
	  }
      }

    if (nargs > 0)
      {
#include <stdarg.h>
	va_list ap;
	va_start (ap, s);
	for (k = 1; k <= nargs; k++)	/* args [0] not assigned! */
	  args[k] = va_arg (ap,	UNNAMED_ARG_TYPE);
	va_end (ap);
      }
  }

  pb = buf;
  tstinit ();
  for (; *s; s++)
    {
      if (*s == '%')
	switch (*++s)
	  {
	  case '%':
	    *pb++ = '%';
	    break;
	  case 'c':
	    *pb++ = tpop ();
	    break;
	  case 'p':
	    i = *++s - '0';
	    if (i < 1 || i > 9)
	      break;
	    tpush (args[i]);
	    break;
	  case 'd':
	    sprintf (number, "%d", tpop ());
	    pb = scpy (number, pb);
	    break;
	  case '\'':
	    if (s[2] == '\'')
	      {
		++s;
		tpush (*s++);
	      }
	    break;
	  case '+':
	    tpush (tpop () + tpop ());
	    break;
	  case 0:
	    s--;
	    break;
	  }
      else
	*pb++ = *s;
    }
  *pb = 0;
  return buf;
}
