/*
 *     
 *
 *     "tv.c"           
 */

#include "nm.h"
#include "sc.h"
#include "kb.h"
#include "trm.h"
#include "ac.h"
#include "tv.h"
#define MAXSHIFT  15

void (*tv_roll_up) (small);
void (*tv_roll_down) (small);

void (*tv_eos_up) (small, small);
void (*tv_eos_down) (small, small);

void (*tv_lines_up) (small, small, small);
void (*tv_lines_down) (small, small, small);

void (*tv_eol_left) (small, small, small);
void (*tv_eol_right) (small, small, small);

void (*tv_text_left) (small, small, small, small);
void (*tv_text_right) (small, small, small, small);

void (*tv_ins_line) (small);
void (*tv_del_line) (small);

void (*tv_ins_char) (small);
void (*tv_del_char) (small);

void (*tv_clr_scrn) (void);
void (*tv_clr_line) (small);
void (*tv_clr_lines) (small, small);
void (*tv_clr_bol) (small, small);
void (*tv_clr_eol) (small, small);
void (*tv_clr_text) (small, small, small);
void (*tv_clr_eos) (small);
void (*tv_clr_bos) (small);

void (*tv_pos) (small, small);

tchar (*tv_swn2blk) (tchar);


local void tv_roll_up0 (small);	/*  parm_index     */
local void tv_roll_up1 (small);	/*  scroll_forward */
local void tv_roll_up2 (small);
local void tv_roll_up3 (small);
local void tv_roll_down0 (small);	/*  parm_rindex    */
local void tv_roll_down1 (small);	/*  scroll_reverse */
local void tv_roll_down2 (small);
local void tv_roll_down3 (small);

local void tv_eos_up0 (small, small);
local void tv_eos_up1 (small, small);
local void tv_eos_down0 (small, small);
local void tv_eos_down1 (small, small);

local void tv_lines_up0 (small, small, small);
local void tv_lines_up1 (small, small, small);
local void tv_lines_up2 (small, small, small);
local void tv_lines_down0 (small, small, small);
local void tv_lines_down1 (small, small, small);
local void tv_lines_down2 (small, small, small);

local void tv_eol_left0 (small, small, small);
local void tv_eol_left1 (small, small, small);
local void tv_eol_right0 (small, small, small);
local void tv_eol_right1 (small, small, small);

local void tv_text_left1 (small, small, small, small);
local void tv_text_right1 (small, small, small, small);

local void tv_ins_line0 (small);	/*  parm_insert_line */
local void tv_ins_line1 (small);	/*  insert_line      */
local void tv_del_line0 (small);	/*  parm_delete_line */
local void tv_del_line1 (small);	/*  delete_line      */

local void tv_ins_char0 (small);
local void tv_ins_char1 (small);	/*  insert_character */
local void tv_del_char0 (small);	/*  parm_dch         */
local void tv_del_char1 (small);	/*  delete_character */

local void tv_clr_scrn0 (void);	/*  clear_screen    */
local void tv_clr_scrn1 (void);

local void tv_clr_line0 (small);	/*  clr_eol */
local void tv_clr_line1 (small);

local void tv_clr_lines1 (small, small);

local void tv_clr_bol0 (small, small);	/*  clr_bol */
local void tv_clr_bol1 (small, small);

local void tv_clr_eol0 (small, small);	/*  clr_eol */
local void tv_clr_eol1 (small, small);

local void tv_clr_text0 (small, small, small);	/*  erase_chars */
local void tv_clr_text2 (small, small, small);

local void tv_clr_eos0 (small);	/*  clr_eos        */
local void tv_clr_eos1 (small);

local void tv_clr_bos0 (small);	/*  clr_bos -   */
local void tv_clr_bos1 (small);

local void tv_pos0 (small, small);	/*  cursor_address      */
local void tv_pos1 (small, small);
local void tv_pos2 (small, small);

local tchar tv_swn2blk_1 (tchar);

void tv_features ();

local void
tv_roll_up0 (register small n)
{
  scpos (0, scy - 1);
  tv_oper (tparm (parm_index, n));
}

local void
tv_roll_up1 (register small n)
{
  scpos (0, scy - 1);
  while (n--)
    tv_oper (scroll_forward);
}

local void
tv_roll_up2 (register small n)
{
  scpos (0, 0);
  (*tv_del_line) (n);
}

local void
tv_roll_up3 (register small n)
{
  register small i;
  for (i = n; i < scy; i++)
    tv_remove_text (0, i, 0, i - n, scx);
}

local void
tv_roll_down0 (register small n)
{
  scpos (0, 0);
  tv_oper (tparm (parm_rindex, n));
}

local void
tv_roll_down1 (register small n)
{
  scpos (0, 0);
  while (n--)
    tv_oper (scroll_reverse);
}

local void
tv_roll_down2 (register small n)
{
  scpos (0, 0);
  (*tv_ins_line) (n);
}

local void
tv_roll_down3 (register small n)
{
  register small i;
  for (i = 0; i < scy - n; i++)
    tv_remove_text (0, i, 0, i + n, scx);
}

local void
tv_eos_up0 (register small y, register small n)
{
  scpos (0, y - n);
  (*tv_del_line) (n);
}

local void
tv_eos_up1 (register small y, register small n)
{
  for (; y < scy; y++)
    tv_remove_text (0, y, 0, y - n, scx);
}

local void
tv_eos_down0 (register small y, register small n)
{
  scpos (0, y);
  (*tv_ins_line) (n);
}

local void
tv_eos_down1 (register small y, register small n)
{
  register int i;
  for (; y < scy - n; y++)
    tv_remove_text (0, y, 0, y + n, scx);
}

local void
tv_lines_up0 (register small y0, register small y1, register small n)
{
  tv_oper (tparm (set_top_and_bottom_margins, y0 - n, y1 - 1));
  cx = cy = 0;
  scpos (0, y1 - 1);
  while (n--)
    tv_oper (scroll_forward);
  tv_oper (tparm (set_top_and_bottom_margins, 0, scy - 1));
  cx = cy = 0;
}

local void
tv_lines_up1 (register small y0, register small y1, register small n)
{
  scpos (0, y0 - n);
  (*tv_del_line) (n);
  scpos (0, y1 - n);
  (*tv_ins_line) (n);
}

local void
tv_lines_up2 (register small y0, register small y1, register small n)
{
  for (; y0 < y1; y0++)
    tv_remove_text (0, y0, 0, y0 - n, scx);
}

local void
tv_lines_down0 (register small y0, register small y1, register small n)
{
  tv_oper (tparm (set_top_and_bottom_margins, y0, y1 + n - 1));
  cx = cy = 0;
  scpos (0, y0);
  while (n--)
    tv_oper (scroll_reverse);
  tv_oper (tparm (set_top_and_bottom_margins, 0, scy - 1));
  cx = cy = 0;
}

local void
tv_lines_down1 (register small y0, register small y1, register small n)
{
  register int i;
  scpos (0, y1 - n + 1);
  (*tv_del_line) (n);
  scpos (0, y0);
  (*tv_ins_line) (n);
}

local void
tv_lines_down2 (register small y0, register small y1, register small n)
{
  register int i;
  for (; y0 < y1; y0++)
    tv_remove_text (0, y0, 0, y0 + n, scx);
}


local void
tv_eol_left0 (register small x, register small y, register small n)
{
  if (n <= MAXSHIFT)
    {
      scpos (x - n, y);
      (*tv_del_char) (n);
    }
  else
    (*tv_text_left) (x, scx, y, n);
}

local void
tv_eol_left1 (register small x, register small y, register small n)
{
  (*tv_text_left) (x, scx, y, n);
}

local void
tv_eol_right0 (register small x, register small y, register small n)
{
  if (n <= MAXSHIFT)
    {
      scpos (x, y);
      (*tv_ins_char) (n);
    }
  else
    (*tv_text_right) (x, scx - n, y, n);
}

local void
tv_eol_right1 (register small x, register small y, register small n)
{
  (*tv_text_right) (x, scx - n, y, n);
}

local void
tv_text_left1 (register small x0, register small x1,
	       register small y, register small n)
{
  tv_remove_text (x0, y, x0 - n, y, x1 - x0);
/* tv_mv_text( spaces, n, x1 - n, y );  */
}

local void
tv_text_right1 (register small x0, register small x1,
		register small y, register small n)
{
  tv_remove_text (x0, y, x0 + n, y, x1 - x0);
/* tv_mv_text( spaces, n, x0, y );      */
}

local void
tv_ins_line0 (register small n)
{
  tv_oper (tparm (parm_insert_line, n));
}

local void
tv_ins_line1 (register small n)
{
  while (n--)
    tv_oper (insert_line);
}

local void
tv_del_line0 (register small n)
{
  tv_oper (tparm (parm_delete_line, n));
}

local void
tv_del_line1 (register small n)
{
  while (n--)
    tv_oper (delete_line);
}

local void
tv_ins_char0 (register small n)
{
  tv_oper (tparm (parm_ich, n));
}

local void
tv_ins_char1 (register small n)
{
  while (n--)
    tv_oper (insert_character);
}

local void
tv_del_char0 (register small n)
{
  tv_oper (tparm (parm_dch, n));
}

local void
tv_del_char1 (register small n)
{
  while (n--)
    tv_oper (delete_character);
}

local void
tv_clr_scrn0 ()
{
  tv_oper (clear_screen);
}

local void
tv_clr_scrn1 ()
{
  scpos (0, 0);
  (*tv_clr_eos) (0);
  scpos (0, 0);
}

local void
tv_clr_line0 (register small y)
{
  scpos (0, y);
  tv_oper (clr_eol);
}

local void
tv_clr_line1 (register small y)
{
  (*tv_clr_text) (0, y, scx);
}

local void
tv_clr_lines1 (register small y0, register small y1)
{
  while (y0 < y1)
    (*tv_clr_line) (y0++);
}

local void
tv_clr_bol0 (register small y, register small n)
{
  scpos (n - 1, y);
  tv_oper (clr_bol);
}

local void
tv_clr_bol1 (register small y, register small n)
{
  (*tv_clr_text) (0, y, n);
}

local void
tv_clr_eol0 (register small y, register small n)
{
  scpos (scx - n, y);
  tv_oper (clr_eol);
}

local void
tv_clr_eol1 (register small y, register small n)
{
  (*tv_clr_text) (scx - n, y, n);
}

local void
tv_clr_text0 (register small x, register small y, register small n)
{
  scpos (x, y);
  tv_oper (tparm (erase_chars, n));
}

local void
tv_clr_text2 (register small x, register small y, register small n)
{
  scpos (x, y);
  while (n--)
    tv_char ((tchar) ' ');
}

local void
tv_clr_eos0 (register small y)
{
  scpos (0, y);
  tv_oper (clr_eos);
}

local void
tv_clr_eos1 (register small y)
{
  register small i;

  i = scy - y;
  while (i--)
    (*tv_clr_line) (scy - i);
}

local void
tv_clr_bos0 (register small y)
{
  scpos (scx - 1, y - 1);
  tv_oper (clr_bos);
}

local void
tv_clr_bos1 (register small y)
{
  register small i;

  for (i = 0; i < y; i++)
    (*tv_clr_line) (i);
}



local void
tv_pos0 (register small x, register small y)
{
  if (!ScLocked)
    tv_oper (tparm (cursor_address, y, x));
  cx = x;
  cy = y;
}

local void
tv_pos1 (register small x, register small y)
{
  if (!x && !y)
    {
      if (!ScLocked)
	tv_oper (cursor_home);
      cx = cy = 0;
      return;
    }
  if (x)
    {
      while (x > cx)
	{
	  if (!ScLocked)
	    tv_oper (cursor_right);
	  cx++;
	}
      while (x < cx)
	{
	  if (!ScLocked)
	    tv_oper (cursor_left);
	  cx--;
	}
    }
  else if (cx != x)
    {
      cx = 0;
      if (!ScLocked)
	tv_oper (carriage_return);
    }
  while (y > cy)
    {
      if (!ScLocked)
	tv_oper (cursor_down);
      cy++;
    }
  while (y < cy)
    {
      if (!ScLocked)
	tv_oper (cursor_up);
      cy--;
    }
}

local void
tv_pos2 (register small x, register small y)
{
  if (x > cx)
    {
      while (x > cx)
	{
	  if (!ScLocked)
	    tv_oper (cursor_right);
	  cx++;
	}
    }
  else
    {
      while (x < cx)
	{
	  if (!ScLocked)
	    tv_oper (cursor_left);
	  cx--;
	}
    }
  if (y > cy)
    {
      while (y > cy)
	{
	  if (!ScLocked)
	    tv_oper (cursor_down);
	  cy++;
	}
    }
  else
    {
      while (y < cy)
	{
	  if (!ScLocked)
	    tv_oper (cursor_up);
	  cy--;
	}
    }
}

local tchar
tv_swn2blk_1 (tchar tc)
{
  return tc ^ AT_INVERT;
}

void
tv_features ()
{
  bool have_tv_ins_line;
  bool have_tv_del_line;
  bool have_tv_ins_char;
  bool have_tv_del_char;

#define have(s) ((char) *(s) /*&& (int)(s)!=(int)&(s)*/   && (s))

  scx = ((small) columns);
  scy = (small) lines_;

  have_tv_ins_line = TRUE;
  if (have (parm_insert_line))
    tv_ins_line = tv_ins_line0;
  else if (have (insert_line))
    tv_ins_line = tv_ins_line1;
  else
    have_tv_ins_line = FALSE;

  have_tv_del_line = TRUE;
  if (have (parm_delete_line))
    tv_del_line = tv_del_line0;
  else if (have (delete_line))
    tv_del_line = tv_del_line1;
  else
    have_tv_del_line = FALSE;

  have_tv_ins_char = TRUE;
  if (have (parm_ich))
    tv_ins_char = tv_ins_char0;
  else if (have (insert_character))
    tv_ins_char = tv_ins_char1;
  else
    have_tv_ins_char = FALSE;

  have_tv_del_char = TRUE;
  if (have (parm_dch))
    tv_del_char = tv_del_char0;
  else if (have (delete_character))
    tv_del_char = tv_del_char1;
  else
    have_tv_del_char = FALSE;

  if (have (parm_index))
    tv_roll_up = tv_roll_up0;
  else if (have (scroll_forward))
    tv_roll_up = tv_roll_up1;
  else if (have_tv_del_line)
    tv_roll_up = tv_roll_up2;
  else
    tv_roll_up = tv_roll_up3;

  if (have (parm_rindex))
    tv_roll_down = tv_roll_down0;
  else if (have (scroll_reverse))
    tv_roll_down = tv_roll_down1;
  else if (have_tv_ins_line)
    tv_roll_down = tv_roll_down2;
  else
    tv_roll_down = tv_roll_down3;

  if (have_tv_del_line)
    tv_eos_up = tv_eos_up0;
  else
    tv_eos_up = tv_eos_up1;

  if (have_tv_ins_line)
    tv_eos_down = tv_eos_down0;
  else
    tv_eos_down = tv_eos_down1;

  if (have (set_top_and_bottom_margins) && have (scroll_forward) &&
      have (scroll_reverse))
    {
      tv_lines_up = tv_lines_up0;
      tv_lines_down = tv_lines_down0;
    }
  else if (have_tv_ins_line && have_tv_del_line)
    {
      tv_lines_up = tv_lines_up1;
      tv_lines_down = tv_lines_down1;
    }
  else
    {
      tv_lines_up = tv_lines_up2;
      tv_lines_down = tv_lines_down2;
    }
  if (have_tv_del_char)
    tv_eol_left = tv_eol_left0;
  else
    tv_eol_left = tv_eol_left1;

  if (have_tv_ins_char)
    tv_eol_right = tv_eol_right0;
  else
    tv_eol_right = tv_eol_right1;

  tv_text_left = tv_text_left1;
  tv_text_right = tv_text_right1;

  if (have (clear_screen))
    tv_clr_scrn = tv_clr_scrn0;
  else
    tv_clr_scrn = tv_clr_scrn1;

  if (have (clr_eol))
    {
      tv_clr_line = tv_clr_line0;
      tv_clr_eol = tv_clr_eol0;
    }
  else
    {
      tv_clr_line = tv_clr_line1;
      tv_clr_eol = tv_clr_eol1;
    }

  tv_clr_lines = tv_clr_lines1;

  if (have (clr_bol))
    tv_clr_bol = tv_clr_bol0;
  else
    tv_clr_bol = tv_clr_bol1;

  if (have (clr_eos))
    tv_clr_eos = tv_clr_eos0;
  else
    tv_clr_eos = tv_clr_eos1;

  if (have (clr_bos))
    tv_clr_bos = tv_clr_bos0;
  else
    tv_clr_bos = tv_clr_bos1;

  if (have (erase_chars))
    tv_clr_text = tv_clr_text0;
  else
    tv_clr_text = tv_clr_text2;

  if (have (cursor_address))
    tv_pos = tv_pos0;
  else if (have (carriage_return) && have (cursor_home))
    tv_pos = tv_pos1;
  else
    tv_pos = tv_pos2;

  tv_swn2blk = tv_swn2blk_1;

#undef have

}
